/*       _        ___
    /\ / /___    / _ \ /\ /\  _ ___
   / // // _ \  / // // // // // _ \
  / // // // / / ___// // // // // /
  \___//_//_/ /_/   /_/ \___/ \_  /
                             \___/

  Copyright (c) 2006, 2007 CompuNach
  Released under the GNU GPL 2.0 or any later version, Copyleft @ 2006
  
  Note: You should have received a copy of the GNU General Public License along
    with this program; if not, visit fsf.org, or write to the Free Software
    Foundation Inc, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
  
  Visit the website:
     unplug.mozdev.org
  
  
  Note: the rules for finding content is in unplug_rulez.js
  Note: the playlist download scripts and ajax are in unplug_playlist.js
  
  THIS FILE is the main code for UnPlug. It handles the scanning, the flag (aka the
  "pagehog" image) and generation of the results page (with the "unclick" events
  it uses).
  
*/

/* DATA TYPE */
function cn_unplug_data() {
   this.url="";
   this.notes="";        // FROM UNPLUG Is guessed
   this.detail="";       // FROM <A> INNERHTML Click Here to Download
   this.media_type=cn_unplug_me_unknown   // from list
   this.media_type_text="" // automatic from media_type - this is filled in automatically
   this.mime="";         // internal: text/html
   this.route="";        // internal: embed.src.generic
   this.flashvars="";    // internal: ?...&....
   this.aquire=false;    // internal: get-playlist?
   this.posted=false;    // internal: outputted to page?
   this.suggest=false;   // internal: suggest for download?
   this.samecount = 1;   // num of times mentioned
   this.forceext = "";   // internal: force this extension when saving
   this.hidden=false;    // internal: if hide bad results is on, hide this one!
   this.postdata="";     // data to HTTP POST, similar to #data:...
}

var cn_unplung_downloads_start = 0;
var cn_unplung_downloads_count = 0;
var cn_unplung_timeout_count = 0;

var cn_unplung_done_startup = false;

var global_window_watch = false;

/* enum */

const cn_unplug_me_max       =15; //top-of-list
const cn_unplug_me_redir     =14; //redirection to host website
const cn_unplug_me_media     =13; //any media .mov ,asf etc
const cn_unplug_me_flv       =12;
const cn_unplug_me_swf       =11;
const cn_unplug_me_textplay  =10;
const cn_unplug_me_link      = 9;
const cn_unplug_me_playlist  = 8;
const cn_unplug_me_rm        = 7;
const cn_unplug_me_torrent   = 6;
const cn_unplug_me_data      = 5; //pointers to downloadable xml data, etc
const cn_unplug_me_ram       = 4;
const cn_unplug_me_flvplay   = 3;
const cn_unplug_me_unknown   = 2; //really unknown, not just any media
const cn_unplug_me_noscore   = 1; //misc/other for placement at bottom
const cn_unplug_me_broken    = 0; // broken links to fix

var cnunplug_tempvar_list = false;
var cnunplug_tempvar_thisurl = false;


//----------Localizing strings ------------//
var gBundle = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
var unplugstrings = gBundle.createBundle("chrome://unplug/locale/unplug.properties");

function cn_unplug_s(s){
   try {
      if (cn_unplug_pref("developer")) {
         //return "<U>{" + s + "|" + unplugstrings.GetStringFromName(s) + "}</U>";
         return "<U>" + unplugstrings.GetStringFromName(s) + "</U>";
      }
      return unplugstrings.GetStringFromName(s);
   } catch (e){
      //return "<U style='color:#400080'>[not translated: " + s + "]</U>";
      return "[not translated: " + s + "]";
   }
}


/******** FREELOADER ICON ************/

function cn_unplug_freeloader(){
   try {
      if (!cn_unplung_done_startup) cn_unplug_domenu();
      
      var gb = getgb();
      if (!gb) return;
      var thiswindow = getgbw();
      
      if (thiswindow && thiswindow.document && thiswindow.document.URL){
      
         //OPEN IN TAB - THIS IS NEW TAB
         if (cn_unplug_prefint("results_window") == 4) {
            if (thiswindow.document.URL.search(/^chrome:\/\/.*unplug.*zuul/) >= 0 && thiswindow.document.getElementById("un_chargrill")) {
               cn_unplug_42(global_window_watch, thiswindow);
               return;
            }
         }
         
         // WINDOW IS RESULTS WINDOW
         if (String(thiswindow.document.URL).search(/^(chrome|file|about):\/\//) >=0 && thiswindow.document.getElementById("cn_photobooth")) {
            cn_unplug_42add(thiswindow, cnunplug_tempvar_list, cnunplug_tempvar_thisurl);
            cnunplug_tempvar_list = false;
            cnunplug_tempvar_thisurl = false;
         }
      }
   
      if (cn_unplug_prefint("pagehog_when") > 0) {
         {
            /* hack for updates */
            var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
            if (prefs.getIntPref("extensions.cn_unplug.pagehog_when") < 4)
               prefs.setIntPref("extensions.cn_unplug.pagehog_when", 20)
         }
   
         window.setTimeout("cn_unplug_freeloader2()", 500);
      }
   } catch(e) {
      cn_unplug_err("freeloader (free1)", e);
   }
}


function cn_unplug_freeloader2(){
/*
  0=never
  10=embed-noflash
  12=embed
  20=any-noflash
  22=any
  30=any+external-noflash
  32=any+external
*/
   try {
      var gb = getgb();
      if (!gb) return;
      var thiswindow = getgbw();
      if (!thiswindow) thiswindow = window;
      if (!thiswindow) return;
      
      var displaywindow = false;
      
      var list = new Array();
      
      var deepsearch = false;
      var showtimer = 8; /* SECONDS */
      if (cn_unplug_prefint("pagehog_when") >= 20) deepsearch = true;
      showtimer = cn_unplug_prefint("pagehog_timeout");
      
      var f = thiswindow.frames;
      for (var i = 0; i < f.length; i++) {
         if (f[i].document){
            if (!displaywindow || displaywindow == false) {
               if (f[i].innerWidth > 150 && f[i].innerHeight > 60
                && f[i].src
                && f[i].document
                && f[i].document.getElementsByTagName("FRAME").length <= 0
                && f[i].document.getElementsByTagName("FRAMESET").length <= 0
               ){
                  displaywindow = f[i];
               }
            }
         }
      }
      cn_unplug_scan2(list, thiswindow, deepsearch);
      
      if (!displaywindow || displaywindow == false) {
         if (thiswindow.top && thiswindow.top.document){
            if (thiswindow.top.document.getElementsByTagName("FRAME").length <= 0 && thiswindow.top.document.getElementsByTagName("FRAMESET").length <= 0){
               displaywindow = thiswindow.top;
            }
         }
      }
      if (!displaywindow || displaywindow == false) {
         if (thiswindow.document){
            displaywindow = thiswindow;
         }
      }
      // last ditch no frameset effort (probably redundent)
      if (displaywindow) {
         if (!displaywindow.document || displaywindow.document.getElementsByTagName("FRAME").length > 0 || displaywindow.document.getElementsByTagName("FRAMESET").length > 0){
            displaywindow = false; /* return */
         }
      }
      
      //errors
      if (!displaywindow || displaywindow == false) return;
      if (!displaywindow.document || !displaywindow.document.body) return;
      if (displaywindow.document.getElementById("cn_unplug_pagehog")) return;
      if (!list) return;

      //derive specials from urls ( copy-n-paste=bad )
      var icount=list.length; //allows for specials to add to end of list without worry of recursion
      for (var i = 0; i < icount; i++) {
         cn_unplug_special_url(thiswindow.document, list, i);
      }
      
      { //check linktype
         var cont=false;
         for (var i = 0; i < list.length; i++) {
            cn_unplug_decodetype(list[i]);
            if (list[i].media_type > cn_unplug_me_unknown) {
               if ((list[i].media_type != cn_unplug_me_swf && list[i].media_type != cn_unplug_me_flvplay) /* isn't flash */ || cn_unplug_prefint("pagehog_when")%10 == 2 /* flash ok */ ){
                  cont=true;
                  break;
               }
            }
         }
         if (!cont) return;
      }
     
      if (list.length > 0 || (keepvid_avaliable(thiswindow.document.URL) != "" && cn_unplug_prefint("pagehog_when") >= 30)){

        var p = displaywindow.document.createElement("img");
        p.src="chrome://unplug/skin/pagehog.png";
        p.border="0px";
        p.alt="UnPlug";
        p.title = list.length + " item(s)";
        p.style.position = "absolute";
        p.style.top = "2px";
        p.style.left = "2px";
        p.id = "cn_unplug_pagehog";
        p.style.zIndex = "60000";
        displaywindow.document.body.appendChild(p);
        p.addEventListener('click', cn_unplug_freeclick, false);
        //timeout to hide icon again
        if (showtimer>0)
           displaywindow.setTimeout("document.getElementById('cn_unplug_pagehog').style.display = 'none';", showtimer*1000);
           
        //make cheese icon if cheesey!
        if (cn_unplug_pref("developer") && displaywindow.document.body.innerHTML.search(/cheese/i) >= 0)
            p.src="chrome://unplug/skin/pagehogcheese.png";
      }
   } catch(e) {
      if (cn_unplug_pref("developer")) cn_unplug_err("freeloader2 (free2)", e);
   }
}

function cn_unplug_freeclick(e){
   if (e.clientX > 171 - 20 && e.clientY < 20){
      try {
         e.target.ownerDocument.getElementById('cn_unplug_pagehog').style.display = 'none';
      } catch (es) {
      //   cn_unplug_err("freeclick (click)", e);
      }
   } else {
      cn_unplug_go();
   }
}

/******** STARTUP ************/

function cn_unplug_domenu()
{
   try
   {
      cn_unplung_done_startup = true;
      if (!cn_unplug_pref("menu_context"))
      {
         var poo = document.getElementById("cn_unplug_pop");
         var pmenu = document.getElementById("contentAreaContextMenu");
         if (poo && pmenu)
         {
            pmenu.removeChild(poo);
         }
      }
      
      // FLASHBLOCK
      if (cn_unplug_pref("use_flashblock"))
      {
         try
         {
            if (Flashblock)
            {
               var sss = Components.classes["@mozilla.org/content/style-sheet-service;1"]
                        .getService(Components.interfaces.nsIStyleSheetService);
               var ios = Components.classes["@mozilla.org/network/io-service;1"]
                        .getService(Components.interfaces.nsIIOService);
               var u = ios.newURI("chrome://unplug/content/flashunblock.css", null, null);
               if ( ! sss.sheetRegistered(u, sss.USER_SHEET) )
                  sss.loadAndRegisterSheet(u, sss.USER_SHEET);
            }
         } catch (e) {
            //cn_unplug_err("domenu", "Flashblock workaround install failed. Error is "+e);
         }
      }
      
      /* toolbar button */
      if (cn_unplug_prefint("startup_code") < 1)
      {
         // save status first
         var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
         prefs.setIntPref("extensions.cn_unplug.startup_code", 1);

         if ( ! document.getElementById("cn-unplug-toolbutton") )
         {
            //add button
            var tb = document.getElementById("nav-bar");
            tb.insertItem("cn-unplug-toolbutton", null, null, false);
            
            //persist
            var currentset = document.getElementById("nav-bar").currentSet;
            tb.setAttribute("currentset",currentset);
            document.persist("nav-bar","currentset");
         }
      }
      
   }
   catch(e)
   {
      if (cn_unplug_pref("developer")) cn_unplug_err("domenu (context-menu-removal)", e);
   }
}


/**************** MAKE PAGE *************/
/*
makes and displays a new results page, opening a tab or window if needed.
New tab has some code in FreeLoader, which diverts a scan of results page
to _42 here
*/

function cnunplug(){
   cn_unplug_go();
}

function cn_unplug_go() {
   /* call this func from buttons, etc */
   try {
      var gb = getgb();
      if (!gb) return;
      var thiswindow = getgbw();
      if (!thiswindow) return;
      
      if (cn_unplug_prefint("results_window") == 4){
         /* tabs */
         if (global_window_watch && global_window_watch != false)
            throw "Already processing one request. Please wait and try again.";
         global_window_watch = thiswindow;
         
         var tab = gb.addTab("chrome://unplug/locale/zuul.html");
         gb.selectedTab = tab;
      } else {
         cn_unplug_42(thiswindow, thiswindow);
      }
   } catch (e) {
      cn_unplug_err("Go (start)", e);
   }
}

function cn_unplug_42(
   thiswindow,
   resultswindow /* is thiswindow for new window/same window, or target tab window to fill*/
){
   try {
      global_window_watch = false;
      
      if (!thiswindow || thiswindow == false) {
         throw "ThisWindow is not defined.";
         return;
      }
      
      var gb = getgb();
      if (!gb) {throw "There is no gBrowser"; return;}
      
      var thisurl = "";
      if (thiswindow.document) thisurl = thiswindow.document.URL;
      
      /* define LIST */
      var list = new Array();
      
      cn_unplug_scan2(list, thiswindow, true);
      
      //check length
      if (!list || list.length <= 0) {
         if (!keepvid_avaliable(thisurl) && !cn_unplug_pref("use_keepvid_always") && !cn_unplug_pref("use_videodownloader_always")) {
            if (cn_unplug_prefint("results_window") == 4) {
               //close zuul/chargrill window
               //var highwin = gb.getBrowserAtIndex(gb.mTabContainer.selectedIndex).contentWindow;
               //if (highwin) highwin.close();;
               resultswindow.close();
            }
            if (cn_unplug_pref("nomedia_alert")) {
               //not using nslPromptService as will swap buttons left<->right, causing confusion
               window.open("chrome://unplug/content/notfound.xul", "", "chrome,dialog,centerscreen,alwaysRaised,modal");
            }
            return;
         }
      }
      
      
      for (var i = 0; i < list.length; i++) {
         // remove tags + whitespace gathered from btn <A>,,,</A> s
         list[i].detail = cn_unplug_striptext(list[i].detail).replace(/( )+/g, " ");
      }
      
      //remove duplicates
      cn_unplug_remove_duplicate(list);
       
      //derive specials from urls
      var icount=list.length; //allows for specials to add to end of list without worry of recursion
      for (var i = 0; i < icount; i++) {
         if (list[i].url != "") {
            list[i].url = cn_unplug_url(thiswindow.document, list[i].url);
            cn_unplug_special_url(thiswindow.document, list, i);
         }
      }
      
      /* NOTE second run - testing! */
      icount=list.length; //allows for specials to add to end of list without worry of recursion
      for (var i = 0; i < icount; i++) {
         if (list[i].url != "") {
            list[i].url = cn_unplug_url(thiswindow.document, list[i].url);
            cn_unplug_special_url(thiswindow.document, list, i);
         }
      }
      
      //remove duplicates (again)
      cn_unplug_remove_duplicate(list);
      
      //remove duplicates (again)
      cn_unplug_remove_annoyances(list);
      
      //fix mimes
      for (var i = 0; i < list.length; i++) {
         cn_unplug_fix_obvious_mimes(list[i]);
         cn_unplug_decodetype(list[i]);
         cn_unplug_can_suggest(list[i]);
      }
      
      //hide "poor links"
      if (cn_unplug_pref("show_poor_suggestions") == false) {
         for (var i = 0; i < list.length; i++) {
            if (list[i].media_type == cn_unplug_me_data
             || list[i].media_type == cn_unplug_me_flvplay
             || list[i].media_type == cn_unplug_me_unknown
             || list[i].media_type == cn_unplug_me_broken
            )
               list[i].hidden = true;
         }
         
         /* if all are hidden, unhide all */
         var all_hidden = true;
         for (var i = 0; i < list.length; i++) {
            if ( ! list[i].hidden) {
               all_hidden = false;
               break;
            }
         }
         if (all_hidden) {
            for (var i = 0; i < list.length; i++)
               list[i].hidden = false;
         }
      }
      
      // ** MAKE PAGE HTML **
      var tx = "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n<HTML><HEAD><TITLE>UnPlug</TITLE><link href='chrome://unplug/skin/unplug" + (cn_unplug_pref("bigger_text")?"_large":"") + ".css' rel='stylesheet' type='text/css'></HEAD>\n<BODY><DIV id='scrolldiv'>";
      if (thiswindow.document.URL) {
         tx += "<DIV class='roflox' id='docurl' unhref='" + cnunhref(thisurl) + "' "
         if (cn_unplug_prefint("results_window") == 0) {
            //open in same window
            tx += "unclick='X-BACK'><A unclick='X-BACK'";
         } else {
            //open in new window / tab
            tx += "unclick='X-CLOSE'><A unclick='X-CLOSE'";
         }
         tx += " href='"+cnunhref(thisurl)+"' class='rofl'>"+cn_unplug_s("FromPage")+" &ldquo;"+cnunhref(thiswindow.document.title)+"&rdquo;</A></DIV>\n<DIV class='bod'>"; 
      }
      
      //ICON
      if (cn_unplug_pref("show_cnicon")) {
         tx += "<A href='http://unplug.mozdev.org' target='_new'><IMG src='chrome://unplug/skin/" + "unplug100.png" + "' alt='Fishy Icon' border='0px' align='right'></A>";
      }
      
      { /******************************************************************** WHAT'S NEW / VERSION */
         const lastupdatever = "1.4.0";
         var verstr = cn_unplug_prefstr("version");
         if (verstr != lastupdatever){
            tx += "<P class='descred'>" + cn_unplug_s("FirstMessage") + ": " + cn_unplug_s("RecentAddition") + "</P><BR>";
            
            var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
            prefs.setCharPref("extensions.cn_unplug.version", lastupdatever);
         }
      }
   
      if (cn_unplug_pref("developer")) {
            tx += "<P class='descred'>" + cn_unplug_s("MessageForDevMode") + "</P><BR>";
      }
      
      //OVERLAIR
      if (cn_unplug_pref("prog_global")) {
         tx += "<DIV class='desc2' id='cn_unplug_overlair'>";
         if (cn_unplug_has_dta() && cn_unplug_pref("prog_allow_over_dta")){
            var hlist="";
            for (var i = 0; i < list.length; i++){
               if (list[i].url){
                  if (hlist.length > 1) hlist += "**";
                  if (list[i].suggest) hlist += "@";
                  hlist += cn_unplug_striptext(list[i].url);
               }
            }
            tx += "<IMG src=\"chrome://unplug/skin/lair_all.png\" alt=\"dta all these\" align=\"absmiddle\" title= \"" + cn_unplug_s("IconDTASaveAll") + "\"  unhref=\"" + hlist + "\" unclick=\"OVERLAIR-DTA\">";
         }
         tx += "</DIV>";
      }
      
      //add links
      var itemcount = 0;
      for (var s = cn_unplug_me_max; s >= 0; s--) {
         for (var i = 0; i < list.length; i++) {
            if (list[i].url != "" && list[i].media_type >= s && !list[i].posted && !list[i].hidden ) {
            
               const typ = Array("no", "no", "unknown", "flvplay", "ram", "data", "torrent", "rm", "play", "link", "textplay", "swf", "flv", "me", "web");

               // IMAGE
               tx += "<IMG src='chrome://unplug/skin/unstar_" + typ[Math.floor(list[i].media_type)] + ".png' height='12px' width='12px' alt='*' align='absmiddle'>";
               
               // LINK URL
               tx += cn_unplug_link(list[i].url, "url");
               
               // NOTES
               if (list[i].notes && list[i].notes != "")
                  tx += "<P class='desc_notes'>" + cn_unplug_striptext(list[i].notes) + "</P>";
               
               // DESCRIPTION
               if (list[i].detail && list[i].detail.length > 1) {
                  list[i].detail = cn_unplug_striptext(list[i].detail);
                  if (list[i].detail.length > 80) {
                     //short
                     tx += "<P class='desc' id='desc_" + i + "s'>" + cn_unplug_s("Name") + ": " + list[i].detail.substring(0, 65) + "... <A class='moreless' unhref='" + i + "' unclick='SHOW-MORE'>" + cn_unplug_s("More") + " &raquo;</A></P>";
                     //full
                     tx += "<P class='desc' id='desc_" + i + "f' style='display:none'>" + cn_unplug_s("Name") + ": " + list[i].detail + " <A class='moreless' unhref='" + i + "' unclick='SHOW-LESS'>&laquo; " + cn_unplug_s("Less") + "</A></P>";
                  } else {
                     tx += "<P class='desc'>"+ cn_unplug_s("Name")+": " + list[i].detail + "</P>";
                  }
               }
               
               // MEDIA TYPE
               tx += "<P class='desc2'>" + cn_unplug_s ("Type")+ ": " + list[i].media_type_text + "</P>";
               if (cn_unplug_pref("developer"))
                  tx += "<P class='desc2'>Media Type: " + list[i].media_type + " / " + cn_unplug_striptext(list[i].mime) + "</P>";
               
               //COUNT
               if (list[i].samecount > 1)
                  tx += "<P class='desc2'>" + cn_unplug_s ("ListedOnPage").replace('#1', cn_unplug_striptext(list[i].samecount)) + "</P>";
               
               // DESCRIPTION
               if (cn_unplug_pref("developer"))
                  tx += "<P class='desc2'>" + i + ": Route: " + cn_unplug_striptext(list[i].route) + "</P>";
               
               //FLASHVARS
               if (list[i].flashvars && list[i].flashvars != "" && cn_unplug_pref("developer")) {
                  tx += "<P class='desc2'>&darr; This box contains the FlashVars information appended to the flash-based player.<BR><TEXTAREA>" + cn_unplug_htmlspecialchars(list[i].flashvars) + "</TEXTAREA></P>";
               }
               
               //LAIR
                  tx += cn_unplug_hells_lair(list[i]);
                  
               //GENERIC
                  itemcount++;
                  list[i].posted = true;
                  tx += "\n"; //better src format for debug
                  
            }
         }
      }
      /* get those missed, ie, ..._score_hidden or hide poor entries things (hidden) */
      if (cn_unplug_pref("developer")){
         for (var i = 0; i < list.length; i++) {
            if (list[i].url != "" && !list[i].posted) {
               // No need to translate this block: it is developer-only
               tx += "<IMG src='chrome://unplug/skin/unstar_no.png' height='12px' width='12px' alt='*' align='absmiddle'>";
               tx += "Hidden Link: " + cn_unplug_striptext(list[i].url);
               tx += "<P class='desc'>Link not shown due to settings or a bug. This message displayed for developers only</P>"
            }
         }
      }
      
      //COUNT / OPTIONS
      tx += "<BR clear='right'><P class='count'>"
      tx += "<IMG src='chrome://unplug/skin/config.png' alt='" + cn_unplug_s("options") + "' align='right' title='" + cn_unplug_s("options") + "' unclick='OPTIONS'>";
      
      var titems = cn_unplug_s ("ItemsOnPage");
      titems = titems.replace('#1', itemcount);
      titems = titems.replace('#2', list.length);
      tx += titems + "</P>";
      
      //PLAYLIST
      // no-translate: not on screen for long enough
      tx += "<BR><BR><DIV id='cn_undown' class='booth' style='display: none'>Checking for playlist download(s)</DIV><DIV id='cn_photobooth'></DIV>";
      tx += "</DIV><BR><BR></DIV></BODY></HTML>";
      
      var dropwin = thiswindow.top;
      if (!dropwin) dropwin = thiswindow;
      
      if (cn_unplug_prefint("results_window") == 4){
         //var highwin = gb.getBrowserAtIndex(gb.mTabContainer.selectedIndex).contentWindow;
         //if (highwin) dropwin = highwin;
         dropwin = resultswindow;
      } else if (cn_unplug_prefint("results_window") == 1){
         var dropwin = thiswindow.open("about:blank", "_cnunplugnew", "");
          if (!dropwin) dropwin = thiswindow;
      } else if (cn_unplug_prefint("results_window") == 2){
         // new tab system opens below
         dropwin = thiswindow;
      } else {
         dropwin.stop();
         //dropwin.location = "chrome://unplug/content/zuul.html";
      }
      
      var genpage = cn_unplug_drencrom(tx);
      if (genpage != "") {
         cnunplug_tempvar_list = list;
         cnunplug_tempvar_thisurl = thisurl;
         
         if (cn_unplug_prefint("results_window") == 2) {
            var tab = gb.addTab(genpage);
            gb.selectedTab = tab;
         } else {
            dropwin.document.location = genpage;
         }

      } else {
         /* failsafe */
         alert("UnPlug is running in failsafe mode. Please view the javascript console and report errors to compunach@yahoo.co.uk")
         
         dropwin.document.open();
         //dropwin.document.clear();
         dropwin.document.write(tx);
         dropwin.document.close();
         cn_unplug_42add(dropwin, list, thisurl)
      }
      
   } catch(e) {
      cn_unplug_err("42 (go make page)", e);
   }

}

function cn_unplug_42add(dropwin, list, thisurl){
   try {
      /* now do downloads:: */
      cn_unplung_downloads_count = cn_unplung_downloads_start = cn_unplung_timeout_count = 0;
      
      /* playlists */
      if (cn_unplug_pref("get_playlists")){
         for (i = 0; i < list.length; i++) {
            if (list[i].aquire){
               cn_unplug_downloadreference(list[i].url, dropwin, list[i].postdata);
            }
         }
      }
      
      /* keepvid */
      if (cn_unplug_pref("use_keepvid")) {
         if (cn_unplug_pref("use_keepvid_always") || keepvid_avaliable(thisurl).indexOf("[keepvid]") >= 0){
            cn_unplug_downloadkeepvid(thisurl, dropwin);
         }
      }
      if (cn_unplug_pref("use_videodownloader")) {
         if (cn_unplug_pref("use_videodownloader_always") || keepvid_avaliable(thisurl).indexOf("[videodownloader]") >= 0){
            //cn_unplug_downloadreference("http://javimoya.com/blog/mybic_server.php?action=ytest&lang=en&url=" + escape(thisurl) + "&site=any_site&=", dropwin);
            cn_unplug_downloadreference("http://videodownloader.net/get/?url=" + escape(thisurl), dropwin);
         }
      }
      
      if (cn_unplung_downloads_start == 0) {
         // hide counter
         var div = dropwin.document.getElementById('cn_undown');
         if (div) div.style.display = 'none';
      }
      
      dropwin.addEventListener('click', cn_unplug_clickyclick, true);


   } catch(e) {
      cn_unplug_err("42add (window add services)", e);
   }
}

function cn_unplug_remove_duplicate(list){
   for (var i = 0; i < list.length; i++) {
      for (var j = 0; j < i; j++) {
         if (list[i].url == list[j].url && list[i].postdata == list[j].postdata) {
            list[i].samecount += list[j].samecount;
            list[j].samecount = 0;
            
            list[j].url = ""; //remove
            list[i].route = cn_unplug_join(list[i].route, list[j].route, " ---- ");
            list[i].notes = cn_unplug_join(list[i].notes, list[j].notes, " - ");
            list[i].detail = cn_unplug_join(list[i].detail, list[j].detail, " - ");
            if (list[j].media_type > list[i].media_type) {
               list[i].media_type = list[j].media_type;
               list[i].media_type_text = list[j].media_type_text;
            }
            list[i].mime = cn_unplug_join(list[i].mime, list[j].mime, " - ");
            list[i].flashvars = cn_unplug_join(list[i].flashvars, list[j].flashvars, " - ");
         }
      }
   }
}


function cn_unplug_fix_obvious_mimes(li){
   var url = String(li.url);
   if (0 <= url.indexOf("youtube.com/get_video?video_id="))
      li.media_type = cn_unplug_me_flv;
   if (0 <= url.indexOf("videoConfigXmlCode"))  // BADJOJO
      li.media_type = cn_unplug_me_data;
}


function cn_unplug_remove_annoyances(list){
   for (var i = 0; i < list.length; i++) {
      var url = list[i].url;
      if (url.indexOf("signout") >= 0 || url.indexOf("logout") >= 0 //evil logout
         || url.indexOf("%3C?xml%20") >= 0 || url.indexOf("<?xml ") >= 0  // raw xml data
//         || url.indexOf("/false") >= 0 || url.indexOf("/true") >= 0  // madness
      )
         list[i].url = "";
   }
}

function cn_unplug_drencrom(content){
   try {
      var dirService = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
      var tmpFile = dirService.get("UChrm", Components.interfaces.nsILocalFile);
      
      tmpFile.appendRelativePath("unplug_drencrom.html");
      
      var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                                .getService(Components.interfaces.nsIIOService);
      var xmlFilePath = ioService.newFileURI(tmpFile).spec;
   
      if(tmpFile.exists()) {
         tmpFile.remove(true);
      }
      tmpFile.create(tmpFile.NORMAL_FILE_TYPE, 0666);
      
      var stream = Components.classes['@mozilla.org/network/file-output-stream;1']
                             .createInstance(Components.interfaces.nsIFileOutputStream);
      stream.init(tmpFile, 2, 0x200, false); // open as "write only"
      
      stream.write(content, content.length);
      stream.flush();
      stream.close();
      
      return xmlFilePath;
   } catch (e) {
      cn_unplug_err("drencrom (write html)", e);
      return "";
   }
}


/********** TOOL **********/

/**
   strips ?... and #... from link
*/
function cn_unplug_mainurl(droot){
   if (droot.indexOf("?") >= 0)
      droot = droot.substring(0, droot.indexOf("?"));
   if (droot.indexOf("#") >= 0)
      droot = droot.substring(0, droot.indexOf("#"));
   return droot;
}



/**
   gets ?...param=[VAlUE]... from url
*/
function cn_unplug_urlget(url, param){
   url = String(url);
   param = String(param).toLowerCase() + "=";
   
   /* searchstring only */
   if (url.indexOf("?") >= 0)
      url = url.substring(url.indexOf("?")+1, url.length);
   
   /* check it's there */
   if (url.toLowerCase().indexOf(param) < 0)
      return "";
   
   /* get it */
   url = url.substring(url.toLowerCase().indexOf(param) + param.length, url.length);
   if (url.indexOf("&") >= 0)
      url = url.substring(0, url.indexOf("&"));
   
   return url;
}

/**
   converts hex style to text
   Use hex digit pairs: 00 01 02 ... fe ff.
   Spaces are ignored.
*/
function unplug_hexstring(tx)
{
   var sout = String("");
   var gotpart = 0;
   for (var i = 0; i < tx.length; i++) {
      var c = tx.charAt(i);
      var n = -1;
      switch (c) {
         case ' ': n = -1; break;
         case '0': n =  0; break;
         case '1': n =  1; break;
         case '2': n =  2; break;
         case '3': n =  3; break;
         case '4': n =  4; break;
         case '5': n =  5; break;
         case '6': n =  6; break;
         case '7': n =  7; break;
         case '8': n =  8; break;
         case '9': n =  9; break;
         case 'A':
         case 'a': n = 10; break;
         case 'B':
         case 'b': n = 11; break;
         case 'C':
         case 'c': n = 12; break;
         case 'D':
         case 'd': n = 13; break;
         case 'E':
         case 'e': n = 14; break;
         case 'F':
         case 'f': n = 15; break;
         default:
            cn_unplug_err("hexstring", "String values are not valid hex");
            return "";
      }
      if (n >= 0)
      {
         if (++gotpart == 2)
         {
            sout += String.fromCharCode(n);
            gotpart = 0;
         }
      }
   }
   return sout;
}


/******** UNPLUG LAIR ************/
/*
unplug lair functions supply the icons for media
player, streaming wizard, etc
*/

function cn_unplug_clickyclick(e){
   try{
      if (e && e.target){
        var tag = e.target.getAttribute("unclick");
        switch (tag){
          case "OPTIONS":
            window.open("chrome://unplug/content/settings.xul", "", "chrome,dialog,centerscreen,alwaysRaised");
            return;
          case "X-CLOSE":
            this.close();
            return false;
          case "X-BACK":
            this.history.go(-1);
            return false;
        }
        if (tag && tag != ""){
          var url = e.target.getAttribute("unhref");
          url = cn_unplug_striptext(url);
          if (!url || url == "") {
            //fail
            cn_unplug_err("clickyclick", "There is no URL attatched to this button.");
            return;
          }
          switch (tag) {
            case "OPENWIN":
               //e.target.ownerDocument.location = "chrome://unplug/locale/" + url;
               
               var gb = getgb();
               var tab = gb.addTab("chrome://unplug/locale/" + url);
               gb.selectedTab = tab;

               return false;
            case "SHOW-MORE":
               e.target.ownerDocument.getElementById("desc_" + url + "f").style.display = "";
               e.target.ownerDocument.getElementById("desc_" + url + "s").style.display = "none";
               return false;
            case "SHOW-LESS":
               e.target.ownerDocument.getElementById("desc_" + url + "f").style.display = "none";
               e.target.ownerDocument.getElementById("desc_" + url + "s").style.display = "";
               return false;
            case "LAIR-CACHE":
               var docz = e.target.ownerDocument;
/* TRANSLATE POINT */
                   if (cn_unplug_pref("coralcache_alert")) {
                  switch (cn_unplug_alertcheck("UnPlug", "This downloads a cached version of the file from nyud.net (coral cache), if possible.\n\nIf the normal link is unavailable (for example, if the website is temporarily offline), you may still be able to download the file from nyud.net. However, this is not private and may be monitored by nyud.net. Terms of service may apply: read them at planet-lab.org\n", "Don't show this again")){
                     case 0:
                        return false;
                     case 2:
                     {
                        var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
                            prefs.setBoolPref("extensions.cn_unplug.coralcache_alert", false);
                         }
                  }
               }
               url = url.replace("//", "[d#]");
               if (url.indexOf("/") < 0) url += "/";
               url = url.replace(/\//, ".nyud.net:8090");
               url = url.replace("[d#]", "//");
               docz.location = url;
               return false;
            case "LAIR-FXSAVE":
               e.target.className = "clicked";
               if (!cn_unplug_ok_protocol(url)) {
                 cn_unplug_err("clickyclick", "Bad Protocol for the URL attatched to this button.");
                 return;
               }
               var ref = null;
               try {
                 ref = e.target.ownerDocument.getElementById("docurl").unhref;
               } catch (e) {}
               
                   var ext = e.target.getAttribute("unext");
                   
                try {
                
                    cn_unplug_super_saveURL( url, ref, ext);
                    
                   } catch (e) {
                      cn_unplug_err("clickyclick internalSave call", e);
                      if (confirm("There were errors when saving.\n\nWould you like to try again using a different method?")){
                      
               /* func should be (as per chrome://global/content/contentAreaUtils.js):
               function saveURL(
                   aURL,               The String representation of the URL of the document being saved
                   aFileName,            The caller-provided suggested filename if we don't find a better one
                   aFilePickerTitleKey,      Alternate title for the file picker
                   aShouldBypassCache,      If true, the document will always be refetched from the server
                   aSkipPrompt,            If true, the file will be saved to the default download folder.
                   aReferrer            the referrer URI object (not URL string) to use, or null if no referrer should be sent.
                  )
                */
                     saveURL( url, "", "", false, false, makeURI(url));
                     
                  }
               }
               
               break;
               
            case "LAIR-PLAY":
            case "LAIR-HELIX":
               e.target.className = "clicked";
               var prog = "";
               if (tag == "LAIR-PLAY")
                 prog = cn_unplug_prefstr("prog_lo_media");
               if (tag == "LAIR-HELIX")
                 prog = cn_unplug_prefstr("prog_lo_helix")
               
               if (prog == "") throw "No program";
               
               // src from http://kb.mozillazine.org/Running_applications
               // create an nsILocalFile for the executable
               var file = Components.classes["@mozilla.org/file/local;1"]
                 .createInstance(Components.interfaces.nsILocalFile);
               file.initWithPath(prog);
               
               // create an nsIProcess
               var process = Components.classes["@mozilla.org/process/util;1"]
                 .createInstance(Components.interfaces.nsIProcess);
               process.init(file);
               
               // Run the process.
               // If first param is true, calling process will be blocked until
               // called process terminates. 
               // Second and third params are used to pass command-line arguments
               // to the process.
               // var args = ["argument1", "argument2"];
               var args = [url];
               process.run(false, args, args.length);
               break;
               
            case "LAIR-STREAM":
               e.target.className = "clicked";
               window.openDialog("chrome://unplug/content/streamsave.xul", "", "chrome,dialog,centerscreen,alwaysRaised,modal", url, window);
               break;
               
            case "LAIR-DTA":
               e.target.className = "clicked";
               DTA_AddingFunctions.saveSingleLink(/* turbo: */ false, url, /* base url: */"", /*description: */"UnPlug Download File");
               break;
               
            case "LAIR-DTATURBO":
               e.target.className = "clicked";
               DTA_AddingFunctions.saveSingleLink(/* turbo: */ true, url, /* base url: */"", /*description: */"UnPlug Download File");
               break;
               
            case "OVERLAIR-DTA":
               e.target.className = "clicked";
               var ua = url.split("**");
               
               dtalist = new Object();
               for (var i = 0; i < ua.length; i++){
                 var uj = ua[i];
                 if (uj.charAt(0) == "@") uj = uj.substring(1, uj.length);
                 var elem = new Object();
                 elem.url = uj;
                 elem.refPage = "";
                 elem.ultDescription = "";
                 elem.description = "UnPlug " + uj.substring(uj.lastIndexOf("/")+1, uj.length);
                 dtalist[uj] = elem;
               }
               dtalist.length = ua.length;
               
               //DTA_AddingFunctions.saveLinkArray(false, dtalist, Array());
               var w = window.openDialog("chrome://dta/content/dta/select.xul","_blank","chrome,centerscreen,resizable=yes,dialog=no", dtalist, Array(), 0);
               
               window.setTimeout(function (){
               cn_unplug_dtafill(w, url) }, 600);
      
               break;
            
            case "LAIRCONFIG":
               e.target.className = "clicked";
               window.openDialog("chrome://unplug/content/settings.xul", "", "chrome,dialog,centerscreen,alwaysRaised,modal", "PROG");
               break;
   
            default:
               cn_unplug_err("clickyclick", "Method " + e.target.getAttribute("unclick") + " (which is attatched to this button) is not supported.");
               break;
          }
        }
      }
   } catch (e) {
      cn_unplug_err("clickyclick (document object click)", e);
   }
}

/************* LINK and GENERAL USE FUNCTIONS ******************/

function cn_unplug_join(a, b, jn){
   if (!b || b.length < 2) return a;
   if (!a || a.length < 2) return b;
   return a + jn + b;
}


function cn_unplug_decodetype(it){
   if (it.media_type == cn_unplug_me_unknown || it.media_type == cn_unplug_me_link){
      
      //try to discover type from url - as mtyp
      //ext first as .asx etc has mime x-ms-asf
      var mtyp = cn_unplug_ftype(it.url, "ext");
      if (mtyp < 0 || mtyp == cn_unplug_me_unknown) {
         // or from mime...
         mtyp = cn_unplug_ftype(it.mime, "mime");
         if (mtyp < 0 || mtyp == cn_unplug_me_unknown) {
            // give up
            mtyp = cn_unplug_me_unknown;
         }
      }
      
      //assign mtyp to media_type
      if (mtyp != cn_unplug_me_unknown) {
         if (it.media_type == cn_unplug_me_link) {
            if (mtyp == cn_unplug_me_textplay || mtyp == cn_unplug_me_data || mtyp == cn_unplug_me_ram || mtyp == cn_unplug_me_torrent)
               it.media_type = mtyp;
         } else {
            it.media_type = mtyp;
         }
      }
   }
   
   switch (it.media_type){
      case cn_unplug_me_redir:
         it.media_type_text = cn_unplug_s("LinkToHost");
         if (it.notes != "") it.notes += " ^_^ ";
         it.notes += cn_unplug_s("GoToSite");
         break;
      case cn_unplug_me_flv:
         it.media_type_text = cn_unplug_s("File_Flv")+cn_unplug_help("flv");
         it.forceext = "flv";
         break;
      case cn_unplug_me_swf:
         it.media_type_text = cn_unplug_s("Flash")+cn_unplug_help("flash");
         it.forceext = "swf";
         break;
      case cn_unplug_me_textplay:
         it.media_type_text = cn_unplug_s("Playlist")+cn_unplug_help("playtext");
         it.aquire = true;
         
         //force badly named or referential wmvs as "asx"
         if (it.url && it.url.indexOf(".wm") >= 0) it.forceext = "asx";
         break;
      case cn_unplug_me_data:
         it.media_type_text = cn_unplug_s("XML_Data"); /* +cn_unplug_help("playtext"); */
         it.aquire = true;
         break;
         
      case cn_unplug_me_ram:
         if ((it.media_type_text && it.media_type_text.toLowerCase().indexOf("smi") >= 0) || (it.url && it.url.toLowerCase().indexOf(".smi") >= 0)) {
            it.media_type_text = cn_unplug_s("File_SMIL")+cn_unplug_help("playtext");
         } else {
            it.media_type_text = cn_unplug_s("File_Ram")+cn_unplug_help("ram");
         }
         it.aquire = true;
         break;
      case cn_unplug_me_rm:
         it.media_type_text = cn_unplug_s("File_Rm")+cn_unplug_help("rm");
         it.aquire = true;
         break;
      case cn_unplug_me_playlist:
         it.media_type_text = cn_unplug_s("Playlist")+cn_unplug_help("playtext");
         break;
      case cn_unplug_me_flvplay:
         it.media_type_text = cn_unplug_s("File_FlvPlayer")+cn_unplug_help("flv");
         it.forceext = "swf";
         break;
      case cn_unplug_me_broken:
         // no need to translate, it SHOULD never appear.
         it.media_type_text = "This link is marked as broken. The most likely reason for this is that the developer's an idiot.";
         break;
   
      case cn_unplug_me_media:
      case cn_unplug_me_noscore:
      case cn_unplug_me_link:
      case cn_unplug_me_unknown:
      default:
         if (!it.media_type_text || it.media_type_text == "")
            it.media_type_text = cn_unplug_ftype(it.mime, "mime-name");
         if (!it.media_type_text || it.media_type_text == "")
            it.media_type_text = cn_unplug_ftype(it.url, "ext-name");
         if (!it.media_type_text || it.media_type_text == "")
            it.media_type_text = cn_unplug_s("dont_know");
         break;
   }
}

function cn_unplug_url(doc, u){
   //return real url
   var droot = "";
   if (doc.URL)
      droot = doc.URL;
   return cn_unplug_url2(droot, u);
}


function cn_unplug_url2(droot, u){
   if (!u || u == "") return "";
   
   if (u.indexOf("%") >= 0) u = unescape(u);
   
   if (u.charAt(0) == "/"){
      u = droot.substring(0, droot.indexOf("/", /*from:*/ droot.indexOf("//")+2)) + u;
   } else if (u.indexOf("://") < 0 || u.indexOf("://") > 8) {
      // is missing http:// in url, assume local link
      u = droot.substring(0, droot.lastIndexOf("/") + 1) + u;
   }
   
   /* resolve ".." in url */
   {
      var emto = 20;
      while (u.indexOf("/../") > 0) {
         /* timeout */
         if (--emto <= 0) {
            cn_unplug_err("url2", "parent directory resolution timeout");
            break;
         }
         
         var i = u.indexOf("/../");
         var path = u.substring(0, i);
         u = path.substring(0, path.lastIndexOf("/")+1)
             + u.substring(i + "/../".length, u.length);
      }
   }
   
   return u;
}

function cn_unplug_a(list, route, url, media_type, mime, notes, detail, flashvars){
   if (!url) {
      cn_unplug_err("a (add to database)", "Link suggested is NULL: " + url + "\nfrom: " + route + "\nmime: " + mime + "\nnotes: " + notes + "\nthis is an error.");
      return;
   }

   list[list.length] = new cn_unplug_data();
   
   list[list.length-1].url = url;
   list[list.length-1].route = route;
   list[list.length-1].mime = mime;
   list[list.length-1].detail = detail;
   list[list.length-1].notes = notes;
   list[list.length-1].flashvars = flashvars;
   
   list[list.length-1].media_type = media_type;
   if (media_type == cn_unplug_me_unknown) {
      list[list.length-1].route += " !no-media-type";
   }
   
   return list[list.length-1];
}

function cn_unplug_long(un){
   //cut long urls to size
   var reg = /^[^\/\?]*@/i;
   if (reg.test(un)) {
      un = un.substring(0, un.indexOf("/")) + "... [username/password] ..." + un.substring(un.indexOf("@")+1, un.length);
   }
   if (un.indexOf("?") >= 0) {
      if (un.length - un.indexOf("?") > 20)
         un = un.substring(0, un.indexOf("?") + 8) + "...&shy;" + un.substring(un.length-10, un.length);
   }
   if (un.length > 60)
      un = un.substring(0, 20) + "...&shy;" + un.substring(un.length-35, un.length);
   
   // prend a help icon for strange protocols
   switch (un.substring(0, un.indexOf("://"))){
      case "rtsp":
      case "rtp":
         un += cn_unplug_icon("rtsp", "warn", "pro");
         break;
      case "http":
         break;
      case "https":
         break;
      case "unplug":
         //faked url
         un += cn_unplug_icon("extern", "help", "help");
         break;
      case "stop":
         //faked url
         un = "This URL has caused an error.";
         break;
      case "ftp":
         un += cn_unplug_icon("ftp", "ftp", "pro");
         break;
      case "mms":
      case "mmsh":
         un += cn_unplug_icon("mms", "warn", "pro");
         break;
      default:
         un += cn_unplug_icon("other", "warn", "pro");
         break;
   }
   return un;
}

/************ HELP ICONS ******************/

function cn_unplug_help(where){
   return cn_unplug_icon(where, "help", "help");
}

function cn_unplug_icon(where, icon, zone){
   /*
   NOTE: DEPRECIATED
   */
   return "";

   if (!cn_unplug_pref("show_help"))
      return "";
   /* show icon ok: */
   
   var itx = " <IMG height=\"22px\" width=\"19px\" border=\"0px\" alt=\"?\" src=\"chrome://unplug/skin/" + icon + ".png\" unclick='OPENWIN' unhref='" + zone + "_" + where + ".html' title=\""+cn_unplug_s("HelpIconText")+"\" align=\"absmiddle\">";
   return itx;
}



/********* DISCOVER MIME/EXT -> MEDIA TYPE *********/


function cn_unplug_ftype(u, op){
   //check file extesion ("ext") or mime ("mime") or name ("name")
   
   if (!u) {
      // throw up
      if (op.indexOf("name") >= 0)
         return ""
      else
         return -2;
   }
   
   var us = u.toLowerCase();
   
   if (op.indexOf("mime") >= 0){
      //all of it
   } else {
      //extension only
      
      if (us.search(/\Wasx\W/) >= 0){
         if (op.indexOf("name") >= 0)
            return "ASX/"
         else
            return cn_unplug_me_textplay;
      }

      if (us.search(/mime(type)?=(video|audio)/) >= 0){
         if (op.indexOf("name") >= 0)
            return "FLV/"
         else
            return cn_unplug_me_flv;
      }
      
      //videodubba.com
      if (us.search(/flvplayer\.php/) >= 0){
         if (op.indexOf("name") >= 0)
            return "XML/"
         else
            return cn_unplug_me_data;
      }

      if (us.indexOf("?") > 0) us = us.substring(0, us.indexOf("?"));
      if (us.indexOf("#") > 0) us = us.substring(0, us.indexOf("#"));
//      if (us.indexOf("/") >= 0) us = us.substring(us.lastIndexOf("/")+1, us.length);
      if (us.indexOf(".") >= 0) us = us.substring(us.lastIndexOf(".")+1, us.length);
      
      //playlist gen tech
      if (us == "php" || us == "aspx"){
         if (u.toLowerCase().indexOf("asx") >= 0) {
            us  = "asx";
         }
      }
      if (u.toLowerCase().indexOf("play2.pl") >= 0){
         if (u.toLowerCase().indexOf("cbs") >= 0) {
            us  = "smil";
         }
      }
      if (u.toLowerCase().indexOf("playlist.dll") >= 0) {
         us  = "asx";
      }
   }
   
   /* declaration */
   function plugme(regex, tname, me){
      this.regex = regex;
      this.tname = tname;
      this.me = me;
   }
   
   var plugmelist = new Array(
      new plugme("asx", "Playlist", cn_unplug_me_textplay),
      new plugme("ashx", "Playlist", cn_unplug_me_textplay), //could be like php?
      new plugme("gvp", "Google Video Player Playlist", cn_unplug_me_textplay),
      new plugme("pls", "Playlist", cn_unplug_me_textplay),
      new plugme("m3u", "Playlist", cn_unplug_me_textplay),
      new plugme("wvx", "Playlist", cn_unplug_me_textplay),
      new plugme("rm", "File_Rm", cn_unplug_me_rm),
      new plugme("ram", "File_Ram", cn_unplug_me_ram),
      new plugme("flv", "File_Flv", cn_unplug_me_flv),
      new plugme("swf", "Flash", cn_unplug_me_swf),
      new plugme("flash", "Flash", cn_unplug_me_swf),
      new plugme("mp4", "File_MP4", cn_unplug_me_media),
      new plugme("mpg4", "File_MP4", cn_unplug_me_media),
      new plugme("mpeg4", "File_MP4", cn_unplug_me_media),
      new plugme("mpg", "File_MPEG", cn_unplug_me_media),
      new plugme("mpeg", "File_MPEG", cn_unplug_me_media),
      new plugme("m4v", "File_MP4", cn_unplug_me_media),
      new plugme("m4a", "File_MP4", cn_unplug_me_media),
      new plugme("m4p", "File_MP4", cn_unplug_me_media),
      new plugme("mp4v", "File_MP4", cn_unplug_me_media),
      new plugme("mov", "File_QT", cn_unplug_me_media),
      new plugme("avi", "File_Media", cn_unplug_me_media),
      new plugme("asf", "File_Media", cn_unplug_me_media),
      new plugme("mkv", "File_MkV", cn_unplug_me_media),
      new plugme("wm", "File_WM", cn_unplug_me_media),
      new plugme("wmv", "File_WM", cn_unplug_me_media),
      new plugme("wma", "File_WM", cn_unplug_me_media),
      new plugme("mp3", "File_MP3", cn_unplug_me_media),
      new plugme("ogg", "File_OGG", cn_unplug_me_media),
      new plugme("wav", "File_WAV", cn_unplug_me_media),
      new plugme("flac", "File_FLAC", cn_unplug_me_media),
      new plugme("smil", "File_Rm", cn_unplug_me_ram),
      new plugme("smi", "File_Rm", cn_unplug_me_ram),
      new plugme("torrent", "File_Torrent", cn_unplug_me_torrent),
      
      /* internal mime */
      new plugme("#textplay", "@internal/textplay", cn_unplug_me_textplay),
      new plugme("#xml", "@internal/xml", cn_unplug_me_redir),
      
      /* generic mimes */
      new plugme("video/", "Video", cn_unplug_me_media),
      new plugme("audio/", "Audio", cn_unplug_me_media) );
   
   if (op.indexOf("mime") >= 0){
      //part-match
      for (var i = 0; i < plugmelist.length; i++){
         if (us.indexOf(plugmelist[i].regex) >= 0){
            //found
            if (op.indexOf("name") >= 0) {
               var n = plugmelist[i].tname;
               if (n.charAt(0) != "@") n = cn_unplug_s(n);
               return n;
            } else {
               return plugmelist[i].me;
            }
         }
      }
   } else {
      //exact match
      for (var i = 0; i < plugmelist.length; i++){
         if (us == plugmelist[i].regex){
            //found
            if (op.indexOf("name") >= 0) {
               var n = plugmelist[i].tname;
               if (n.charAt(0) != "@") n = cn_unplug_s(n);
               return n;
            } else {
               return plugmelist[i].me;
            }
         }
      }
   }
   
   if (op.indexOf("name") >= 0)
      return ""
   else
      return -2;
}


function cn_unplug_can_suggest(it){
   /* suggest as downloadable */
   switch (it.media_type){
      case cn_unplug_me_flv:
      case cn_unplug_me_media:
         it.suggest = true;
         break;
      case cn_unplug_me_link:
      case cn_unplug_me_unknown:
         var he = cn_unplug_ftype(it.url, "ext");
         var hm = cn_unplug_ftype(it.mime, "mime");
         if (he == cn_unplug_me_media || hm == cn_unplug_me_media) {
            it.suggest = true;
         }
         break;
      default:
         break;
   }
}




/***************** PREFS ***************/

function cn_unplug_prefint(wh){
   var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
   return prefs.getIntPref("extensions.cn_unplug." + wh);
}

function cn_unplug_pref(wh){
   // do not call err() from here
   var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
   return prefs.getBoolPref("extensions.cn_unplug." + wh);
}

function cn_unplug_prefstr(wh){
   var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
   return prefs.getCharPref("extensions.cn_unplug." + wh);
}

function cn_unplug_has_dta(){
   try {
      if (DTA_AddingFunctions)
         return true;
      return false;
   } catch (e) {
      return false;
   }
}



function cn_unplug_unquote(tx){
   if (!tx) return "";
   
   if (tx.indexOf("\"") > 0 && tx.indexOf("\"") < 5){
      tx = tx.substring(tx.indexOf("\"")+1, tx.length);
      tx = tx.substring(0, tx.indexOf("\""));
   }
   if (tx.indexOf("\'") > 0 && tx.indexOf("\'") < 5){
      tx = tx.substring(tx.indexOf("\'")+1, tx.length);
      tx = tx.substring(0, tx.indexOf("\'"));
   }
   return tx;
}


/*********** LINK ***********/

function cn_unplug_link(uout, class){
   uout = cnunhref(uout);
   if (uout.indexOf("stop://") >= 0 || (cn_unplug_pref("warn_local_links") && uout.indexOf("file://") >= 0 && uout.indexOf("file://") < 5) || (uout.indexOf("chrome://") >= 0 && uout.indexOf("chrome://") < 5)){
      // stop if protocol is chrome or file, or if link is stop
      return "<B class='stop'>" + cn_unplug_s("LinkDisabled") + "</B> " + cn_unplug_icon("stop", "warn", "help");
   }
   return "<A href=\"" + uout + "\" title=\"" + uout + "\" class=\"" + class + "\">" + cn_unplug_long(uout) + "</A>"
}

function cn_unplug_ok_protocol(un){
   switch (un.substring(0, un.indexOf("://"))){
      case "http":
      case "https":
      case "gopher":
      case "ftp":
      case "post":   // special case
         return true; //ok
      case "file":
         if (cn_unplug_pref("warn_local_links")) return false; //warn as local
         return true; //ok
      default:
         return false;
   }
   return false;
}

function cnunhref(url){
   if (!url) return "";
   try {
      /* link is urlencoded? */
      {
         var a = url.toLowerCase();
         if (a.indexOf("?") >= 0)
            a = a.substring(0, a.indexOf("?"));
         if (a.indexOf("%3a")>=0 || a.indexOf("%2f")>=0 || a.indexOf("%20")>=0)
            url = unescape(url);
      }
      
      //url = url.replace(/&/g, escape("&")); - causes problems with ?...
      url = url.replace(/\'/g, escape("\'"));
      url = url.replace(/\"/g, escape("\""));
      url = url.replace(/</g, escape("<"));
      url = url.replace(/>/g, escape(">"));
      
      /* throw error on stupid links */
      if (url.search(/javascript:/i) >= 0) throw "no js links";
      if (url.search(/chrome:/i) >= 0) throw "no chrome links";
      
      /* throw if urlencoded "@" is encountered as I can't remember whther this is accepted for username/password verification */
      if (url.search(/^[^\/\?]*%40/i) >= 0) throw "link contains %40, which means it could be attempting to spoof the web address";
      
      return url;
   } catch(e) {
      cn_unplug_err("cnunhref", "Link \"" + url + "\" has failed, with error: " + e);
      return "stop:// this url has caused an error.";
   }
}

function cn_unplug_htmlspecialchars(tx){
   tx = String(tx);
   try {
      /* link is urlencoded? */
      
      //url = url.replace(/&/g, escape("&")); - causes problems with ?...
      tx = tx.replace(/</g, "&lt;");
      tx = tx.replace(/>/g, "&gt;");
      
      return tx;
   } catch(e) {
      cn_unplug_err("htmlspecialchars", e);
   }
}

function cn_unplug_striptext(tx){
   /* strip tags */
   if (!tx) return "";
   tx = String(tx); //in case it's not a string

   var txs = tx.split(/</);
   for (var i = 0; i < txs.length; i++)
      txs[i] = txs[i].substring(txs[i].indexOf(">")+1, txs[i].length);
   tx = txs.join(" ");
   return cnunhref(tx);
}



function cn_unplug_dtafill(w, u, t){
   try {
      var links = w.arguments[0];
      for (i in links){
         var tf = (u.indexOf("@" + i) >= 0)?true:false;
         links[i].manuallyChecked = tf;
         var g = w.document.getElementById("file"+i)
         if (g) {
            g.setAttribute("value", tf);
            
            var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
            if (prefs.getBoolPref("extensions.dta.context.highlight")) {
               if (tf) g.parentNode.setAttribute("properties" ,"manuallySelected");
               else g.parentNode.removeAttribute("properties");
            }
         } else if (i == "length") { ;} //wtf tis is for, i dunno
         else throw "Not found item: file"+i;
      }
   } catch(e){
      cn_unplug_err("dtafill", e);
   }
}

function getgb(){
   try {
      switch (cn_unplug_prefint("app")) {
         case 20:
            var gbr = document.getElementById("frame_main_pane");
            return gbr;
         case 0:
         default:
            return gBrowser;
      }
   } catch (e) {
      cn_unplug_err("Do not try to get gBrowser", "Instead try to realise the truth - there is no gBrowser");
      return null;
   }
}

function getgbw(){
   try {
      var gb = getgb();
      if (cn_unplug_prefint("app") == 20)
         return gb.contentWindow;
      return gb.getBrowserAtIndex(gb.mTabContainer.selectedIndex).contentWindow;
   } catch (e) {
      cn_unplug_err("getgbw", "I for one welcome our new Window-Opening overlords");
      return null;
   }
}

function cn_unplug_lair_url(u, me){
   try {
      var li = new cn_unplug_data();
      li.url = u;
      if (me > 0) li.media_type = me;
      cn_unplug_decodetype(li);
      return cn_unplug_hells_lair(li);
   } catch (e) {
      cn_unplug_err("lair_url", "Lair buttons");
      return null;
   }
}

function cn_unplug_hells_lair(li){
   var tx = "";
   
   //ICON LAIR
   if (!cn_unplug_pref("prog_global")) return "";
   
   var downloadable = false;
   var playable = false;
   var helix = false;
   
   if (li.url.indexOf("stop://") >= 0) return "";
   
   var pr = li.url.substring(0, li.url.indexOf("://"));
   if (li.url.indexOf("://") < 0 || cn_unplug_ok_protocol(li.url)){
      downloadable = true;
   }
   if (li.media_type == cn_unplug_me_redir || li.media_type == cn_unplug_me_playlist || li.media_type == cn_unplug_me_textplay || li.media_type == cn_unplug_me_data || li.media_type == cn_unplug_me_ram || li.media_type == cn_unplug_me_torrent) {
      downloadable = false;
   }
   if (li.media_type == cn_unplug_me_media || li.media_type == cn_unplug_me_flv || li.media_type == cn_unplug_me_link /* possibly */ || li.media_type == cn_unplug_me_playlist /* playlist */ || li.media_type == cn_unplug_me_textplay /* playlist */ || li.media_type == cn_unplug_me_data /* playlist */) {
      playable = true;
   }
   if (li.media_type == cn_unplug_me_rm  || li.media_type == cn_unplug_me_ram){
      helix = true;
   }

   tx += "<DIV class=\"lair\">";
   if (cn_unplug_pref("prog_allow_dta")) { //show dTa
      if (cn_unplug_has_dta()){
         if (downloadable) {
            tx += "<IMG src=\"chrome://unplug/skin/lair_turbo.png\" alt=\"dta - turbo\" align=\"absmiddle\" title= \"" + cn_unplug_s("IconDTATurbo") + "\"  unhref=\"" + cn_unplug_striptext(li.url) + "\" unclick=\"LAIR-DTATURBO\">";
            tx += "<IMG src=\"chrome://unplug/skin/lair_dta.png\" alt=\"dta\" align=\"absmiddle\" title= \"" + cn_unplug_s("IconDTASave") + "\"  unhref=\"" + cn_unplug_striptext(li.url) + "\" unclick=\"LAIR-DTA\">";
         } else {
            tx += "<IMG src=\"chrome://unplug/skin/lair_no.png\" alt=\"disabled\" align=\"absmiddle\" title= \"" + cn_unplug_s("IconNotAvaliable") + "\">";
            tx += "<IMG src=\"chrome://unplug/skin/lair_no.png\" alt=\"disabled\" align=\"absmiddle\" title= \"" + cn_unplug_s("IconNotAvaliable") + "\">";
         }
      }
   }
   {
      tx += "<IMG src=\"chrome://unplug/skin/lair_cache.png\" alt=\"cache\" align=\"absmiddle\" title= \"Download via Coral Cache\" unclick=\"LAIR-CACHE\" unhref=\"" + cn_unplug_striptext(li.url) + "\">";
   }
   if (cn_unplug_pref("prog_allow_vlc")) { //show stream+store
      if (playable || downloadable){
         if (cn_unplug_prefstr("prog_lo_vlc") != ""){
            tx += "<IMG src=\"chrome://unplug/skin/lair_stream.png\" alt=\"stream\" align=\"absmiddle\" title= \"" + cn_unplug_s("IconVLC") + "\"  unhref=\"" + cn_unplug_striptext(li.url) + "\" unclick=\"LAIR-STREAM\">";
         } else {
            tx += "<IMG src=\"chrome://unplug/skin/lair_config.png\" alt=\"disabled\" align=\"absmiddle\" title= \"" + cn_unplug_s("IconVLC_Config") + "\" unclick=\"LAIRCONFIG\" unhref=\"#vlc\">";
         }
      } else {
         tx += "<IMG src=\"chrome://unplug/skin/lair_no.png\" alt=\"disabled\" align=\"absmiddle\" title= \"" + cn_unplug_s("IconNotAvaliable") + "\">";
      }
   }
   if (li.media_type == cn_unplug_me_torrent) {
      tx += "<IMG src=\"chrome://unplug/skin/lair_no.png\" alt=\"disabled\" align=\"absmiddle\" title= \"Here be dragons\">";
   } else if (playable) {
      if (cn_unplug_pref("prog_allow_media")){
         if (cn_unplug_prefstr("prog_lo_media") != ""){
            tx += "<IMG src=\"chrome://unplug/skin/lair_play.png\" alt=\"play\" align=\"absmiddle\" title= \"" + cn_unplug_s("IconMedia") + "\"  unhref=\"" + cn_unplug_striptext(li.url) + "\" unclick=\"LAIR-PLAY\">";
         } else {
            tx += "<IMG src=\"chrome://unplug/skin/lair_config.png\" alt=\"disabled\" align=\"absmiddle\" title= \"" + cn_unplug_s("IconMedia_Config") + "\" unclick=\"LAIRCONFIG\" unhref=\"#media\">";
         }
      }
   } else if (helix){
      if (cn_unplug_pref("prog_allow_helix")){
         if (cn_unplug_prefstr("prog_lo_helix") != ""){
            tx += "<IMG src=\"chrome://unplug/skin/lair_helix.png\" alt=\"play - helix\" align=\"absmiddle\" title= \"" + cn_unplug_s("IconRMPlay") + "\"  unhref=\"" + cn_unplug_striptext(li.url) + "\" unclick=\"LAIR-HELIX\">";
         } else {
            tx += "<IMG src=\"chrome://unplug/skin/lair_config.png\" alt=\"disabled\" align=\"absmiddle\" title= \"" + cn_unplug_s("IconRMPlayConfig") + "\" unclick=\"LAIRCONFIG\" unhref=\"#real\">";
         }
      }
   } else if (cn_unplug_pref("prog_allow_helix") && cn_unplug_pref("prog_allow_media")) {
      tx += "<IMG src=\"chrome://unplug/skin/lair_no.png\" alt=\"disabled\" align=\"absmiddle\" title= \"" + cn_unplug_s("IconNotAvaliable") + "\">";
   }
   if (cn_unplug_pref("prog_allow_fxsave")) { //show fx download option
      if (downloadable){
         tx += "<IMG src=\"chrome://unplug/skin/lair_fxsave.png\" alt=\"save\" align=\"absmiddle\" title= \"" + cn_unplug_s("IconSaveFirefox")  + "\"  unhref=\"" + cn_unplug_striptext(li.url) + "\" unclick=\"LAIR-FXSAVE\" unext=\"" + cn_unplug_striptext(li.forceext) + "\">";
      } else {
         tx += "<IMG src=\"chrome://unplug/skin/lair_no.png\" alt=\"disabled\" align=\"absmiddle\" title= \"" + cn_unplug_s("IconNotAvaliable") + "\">";
      }
   }
   tx += "</DIV>";
   
   return tx;
}

/* STREAMING WIZZ */

/* this func required on timer, when window has closed */
function cn_unplug_streamzoo(dest){
   try {
      var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
      var vlc_loc = prefs.getCharPref("extensions.cn_unplug.prog_lo_vlc");
      
      //open vlc (2nd time for 2-step)
      var file = Components.classes["@mozilla.org/file/local;1"]
         .createInstance(Components.interfaces.nsILocalFile);
      file.initWithPath(vlc_loc);
      var process = Components.classes["@mozilla.org/process/util;1"]
         .createInstance(Components.interfaces.nsIProcess);
      process.init(file);
      
      var args = [dest];
      if (cn_unplug_prefint("prog_vlc_new_player") == 1
      || (cn_unplug_prefint("prog_vlc_new_player") == -1 && vlc_loc.search(/^[A-Z]:/i) >= 0)) {
         args[args.length] = "--no-one-instance";
      }
      process.run(false, args, args.length);
      
   } catch(e) {
      cn_unplug_err("streamzoo (open vlc late)", e);
   }
}

/****** ERROR *******/
function cn_unplug_err(func, tx){
   try {
      var errtx = "In UnPlug, in the function:\n\t" + func + "\nthe following horrible error occured:\n\t" + tx;
      
      var ConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
      ConsoleService.logStringMessage(errtx);
   
      if (cn_unplug_pref("alert_errors"))
         alert(errtx);
   } catch (e){
      alert("There were multiple failures in UnPlug. In function\n\terr (error)\nthe error was\n\t" + e + "\nThis followed an error in function\n\t" + func + "\nthe error was\n\t" + tx);
   }
}

/* EVENT HOOKS */
window.addEventListener('load', cn_unplug_freeloader, true);



function unplug_hello_songbird() {
   try {
      var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
      prefs.setIntPref("extensions.cn_unplug.app", 20);
      prefs.setBoolPref("extensions.cn_unplug.prog_global", false);
   } catch (e) {
      cn_unplug_err("songbird", e);
   }
}

/* CN UNPLUG SPER-SAVE-URL, snipped from internalSave in chrome://global/content/contentAreaUtils.js, by mozilla, edited by djb as highlighted */
/* A version of internal save which takes arguments as saveURL but forces .flv etc where needed */
function cn_unplug_super_saveURL(aURL, aReferrer, forceext) {
  /* djb: make args as internalsave */
  var aContentType = null;
  var aShouldBypassCache = false;

  var saveMode = GetSaveModeForContentType(aContentType);
  var saveAsType = kSaveAsType_Complete;

  var file, fileURL;
  // Find the URI object for aURL and the FileName/Extension to use when saving.
  var fileInfo = new FileInfo("");
  
  var charset = null;
      
  initFileInfo(fileInfo, aURL, false, aContentType, null, charset);

  if (forceext && forceext != "")
     fileInfo.fileExt = forceext;
     
    var fpParams = {
      fpTitleKey: "",
      isDocument: false,
      fileInfo: fileInfo,
      contentType: aContentType,
      saveMode: saveMode,
      saveAsType: saveAsType,
      file: file,
      fileURL: fileURL
    };

    if (!getTargetFile(fpParams, false))
      // If the method returned false this is because the user cancelled from
      // the save file picker dialog.
      return;

    saveAsType = fpParams.saveAsType;
    saveMode = fpParams.saveMode;
    file = fpParams.file;
    fileURL = fpParams.fileURL;

  if (!fileURL)
    fileURL = makeFileURI(file);

  // XXX We depend on the following holding true in appendFiltersForContentType():
  // If we should save as a complete page, the saveAsType is kSaveAsType_Complete.
  // If we should save as text, the saveAsType is kSaveAsType_Text.
  var useSaveDocument = false
  // If we're saving a document, and are saving either in complete mode or
  // as converted text, pass the document to the web browser persist component.
  // If we're just saving the HTML (second option in the list), send only the URI.
  var source = fileInfo.uri;
  var persistArgs = {
    source      : source,
    contentType : aContentType,
    target      : fileURL,
    postData    : null,
    bypassCache : aShouldBypassCache
  };

  var persist = makeWebBrowserPersist();

  // Calculate persist flags.
  const nsIWBP = Components.interfaces.nsIWebBrowserPersist;
  const flags = nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES;
  if (aShouldBypassCache)
    persist.persistFlags = flags | nsIWBP.PERSIST_FLAGS_BYPASS_CACHE;
  else
    persist.persistFlags = flags | nsIWBP.PERSIST_FLAGS_FROM_CACHE;

  // Leave it to WebBrowserPersist to discover the encoding type (or lack thereof):
  persist.persistFlags |= nsIWBP.PERSIST_FLAGS_AUTODETECT_APPLY_CONVERSION;

  // Create download and initiate it (below)
  var tr = Components.classes["@mozilla.org/transfer;1"].createInstance(Components.interfaces.nsITransfer);

    tr.init(source, persistArgs.target, "", null, null, null, persist);
    
    persist.progressListener = tr;
    persist.saveURI(source, null, aReferrer, persistArgs.postData, null, persistArgs.target);
}

/* end code snip */

/* Alert box + checkbox */
function cn_unplug_alertcheck(title, text, boxtext) {
   /* returns 0 on cancel; 1 on ok; 2 on ok+checkbox */
   var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
   var checked = {};
   
   if (!promptService.confirmCheck(window, title, text, boxtext, checked)) 
      return 0;
   if (checked.value) return 2;
   return 1;
}

