/*       _        ___
    /\ / /___    / _ \ /\ /\  _ ___
   / // // _ \  / // // // // // _ \
  / // // // / / ___// // // // // /
  \___//_//_/ /_/   /_/ \___/ \_  /
                             \___/

  Copyright (c) 2006, 2007 CompuNach
  Released under the GNU GPL 2.0 or any later version, Copyleft @ 2006
  
  Note: You should have received a copy of the GNU General Public License along
    with this program; if not, visit fsf.org, or write to the Free Software
    Foundation Inc, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
  
  Visit the website:
     unplug.mozdev.org
  
  
  THIS FILE contains a list of RegExps for URLs for where different external websites
  (like KeepVid and VideoDownloader) appear to work.
  
  
  
  
  
  
  
  
  
  
  Add these to VidDownloader:
   Pornotube, Guba (free videos), GameTrailers (users videos) and DailyEpisodes (Simpsons, Futurma, etc...) !
  
  
*/


function keepvid_avaliable(url){
   var loci = "";
   if (!url) return "";
   try {
      /* KEEPVID REGEX URL LIST */
      var keepvid_list=new Array(
         /angryalien\.com\/[0-9]*/i,
         /artistdirect\.com.*player/i,
         /blastro\.com/i,
         /blennus\.com.*view/i,
         /blip\.tv\/file/i,
         /bofunk\.com\/video/i,
         /bolt\.com\/.*\/video/i,
         /break\.com\/movies/i,
         /\.castpost\.com\/[0-9]*\.html/i,
         /current\.tv/i,
         /dailymotion\.com\/.*video\//i,
         /devilducky\.com\/media\/[0-9]+/i,
         /findvideos\.com/i,
         /video\.freevideoblog\.com/i,
         /video\.google.*\/videoplay/i,
         /grinvi\.greenshines\.com/i,
         /grouper\.com/i,
         /ifilm\.com\/player/i,
         /onlineanime\.keiichianimeforever\.com\/player\//i,
         /lulu\.tv.p=/i,
         /metacafe\.com/i, 
         /midis\.biz/i,
         /music\.com\/video.clipid=/i,
         /musicvideocodes\.info\/song/i,
         /vids\.myspace\.com/i,
         /myspacevideocode\.com\/v-/i,
         /newgrounds\.com/i,
         /pcplanets\.com\/(video|mp)/i,
         /pixparty\.com.\/v_/i,
         /media\.putfile\.com/i,
         /revver\.com.\/video\//i,
         /sharkle\.com/i,
         /videos\.streetfire\.net\/video/i,
         /thatvideosite\.com\/view/i,
         /theonenetwork\.com/i,
         /videocodes4u\.com\/song.php/i,
         /videocodesworld\.com\/video.php/i,
         /videocodezone\.com\/videos/i,
         /vidilife\.com.media\.play/i,
         /vidnet\.com/i,
         /vimeo\.com/i,
         /vsocial\.com\/video/i,
         /web62\.com\/videos/i,
         /youtube\.com\/(watch|v\/)/i,
         /zippyvideos\.com/i   );
      for (i=0; i < keepvid_list.length; i++){
         if (url.search(keepvid_list[i]) >= 0){
            loci += "[keepvid]";
            break;
         }
      }
      
      /* VIDEODOWNLOADER */
      var downloaderlist = new Array(
         /animeepisodes\.net\/video/i,
         /badjojo\.com.video\.php/i,
         /blastro\.com/i,
         /bofunk\.com\/video/i,
         /bolt\.com\/.*\/video/i,
         /\.castpost\.com\/[0-9]*\.html/i,
         /collegehumor\.com/i,
         /current\.tv/i,
         /dachix\.com.show=video/i,
         /danerd\.com\/.*vid=/i,
         /dailysixer\.com\/.+\.shtml/i,
         /devilducky\.com\/media\/[0-9]+/i,
         /doubleagent\.com/i,
         /evtv1\.com/i,
         /findvideos\.com/i,
         /hiphopdeal\.com\/article/i,
         /kontraband\.com\/show/i,
         /lulu\.tv.p=/i,
         /midis\.biz/i,
         /music\.com/i,
         /musicvideocodes\.info\/song/i,
         /newgrounds\.com/i,
         /nothingtoxic\.com\/media/i,
         /pcplanets\.com\/(video|mp)/i,
         /pixparty\.com.\/v_/i,
         /plsthx\.com/i,
         /revver\.com.\/video\//i,
         /sharkle\.com/i,
         /smithappens\.com\/video/i,
         /videos\.streetfire\.net\/video/i,
         /thatvideosite\.com\/view/i,
         /videocodes4u\.com\/song.php/i,
         /videocodesworld\.com\/video.php/i,
         /videocodezone\.com\/videos/i,
         /vimeo\.com/i,
         /yikers\.com\/video_/i,
         /angryalien\.com\/[0-9]*/i,
         /blennus\.com.*view/i,
         /blip\.tv\/file/i,
         /break\.com\/movies/i,
         /dailymotion\.com\/.*video\//i,
         /doubleagent\.com/i,
         /evideoshare\.com\/view/i,
         /video\.freevideoblog\.com/i,
         /video\.google.*\/videoplay/i,
         /grinvi\.greenshines\.com/i,
         /ifilm\.com\/player/i,
         /metacafe\.com/i,
         /vids\.myspace\.com/i,
         /myspacevideocode\.com\/v-/i,
         /media\.putfile\.com/i,
         /totallycrap\.com\/media/i,
         /vidilife\.com.media\.play/i,
         /vsocial\.com\/video/i,
         /youtube\.com\/(watch|v\/)/i,
         /zippyvideos\.com/i     );
      for (i=0; i < downloaderlist.length; i++){
         if (url.search(downloaderlist[i]) >= 0){
            loci += "[videodownloader]";
            break;
         }
      }
   } catch(e) {
      cn_unplug_err("unplug_extern.js", e);
//      return "";
   }

   /* end */
   return loci;
}
