/*       _        ___
    /\ / /___    / _ \ /\ /\  _ ___
   / // // _ \  / // // // // // _ \
  / // // // / / ___// // // // // /
  \___//_//_/ /_/   /_/ \___/ \_  /
                             \___/

  Copyright (c) 2006, 2007 CompuNach
  Released under the GNU GPL 2.0 or any later version, Copyleft @ 2006
  
  Note: You should have received a copy of the GNU General Public License along
    with this program; if not, visit fsf.org, or write to the Free Software
    Foundation Inc, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
  
  Visit the website:
     unplug.mozdev.org
  
  
  THIS FILE handles the XML and other playlist downloads
  
*/


/*************** PLAYLIST DOWNLOADS ****************/

function cn_unplug_downloadreference(url, thiswindow, postdata_in){
   if (!url || url == "" || !cn_unplug_ok_protocol(url)) return;
   
   try {
      var post = false;
      var http_head = false;
      var postdata = null;
      var realurl = url;
      
      // split url, fixing realurl as needed.
      var urllist = url.split(" ##");
      if (urllist.length > 1)
         realurl = urllist[0];
      
      // Check if POST, and fix realurl if needed
      if (realurl.toLowerCase().indexOf("post://") == 0) {
         post = true;
         postdata = postdata_in;
         realurl = "http:" + realurl.substring(realurl.indexOf("//"), realurl.length);
      }
      
      // check if ##head
      for (var i = 1; i < urllist.length; i++) {
         var ui = urllist[i];
         var key = ui.substring(0, ui.indexOf(":"));
         var data = ui.substring(ui.indexOf(":")+1, ui.length);
         
         switch (key.toLowerCase()) {
            case "head":
               http_head = true;
               break;
            case "b":
               return cn_unplug_downloadreference_binary(url, thiswindow, postdata_in);
            default:
               break;
         }
      }
      
      // Broadcast status
      cn_unplung_downloads_start++;
      unplug_download_update(thiswindow.document);
      
      //Begin request
      var hx = new XMLHttpRequest;
      if (post)
         hx.open('POST', realurl, true);
      else if (http_head)
         hx.open('HEAD', realurl, true);
      else
         hx.open('GET', realurl, true);
      hx.overrideMimeType('text/plain');
      hx.onreadystatechange = function () {
         try {
            if (hx.readyState == 4) {
               cn_unplung_downloads_count++;
               unplug_download_update(thiswindow.document);
               if(hx.status == 200) {
                  cn_unplug_skimread(url, hx.responseText, thiswindow, hx.getAllResponseHeaders());
               } else {
                  cn_unplug_skimread(url, "<err>"+cn_unplug_s("HTTPError")+hx.status, thiswindow, null);
               }
            }
         } catch(e){
            //cn_unplug_err("downloadreference.internal", e);
         }
      };
      //hx.setRequestHeader("Host", "");
      hx.setRequestHeader("Accept", "text/*, */*;q=0");
      
      
      // Extra data
      for (var i = 1; i < urllist.length; i++) {
         var ui = urllist[i];
         var key = ui.substring(0, ui.indexOf(":"));
         var data = ui.substring(ui.indexOf(":")+1, ui.length);
         
         switch (key.toLowerCase()) {
            case "data":
               if (post)
                  postdata = data;
               break;
            case "content-type":
            case "type":
               hx.setRequestHeader("Content-Type", data);
               break;
            case "cookie":
               hx.setRequestHeader("Cookie", data);
               break;
            case "form":
               hx.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
               if (post)
                  postdata = data;
               break;
            case "referer":
            case "ref":
               hx.setRequestHeader("Referer", data);
               break;
         }
      }
      
      //send
      hx.send(postdata);
      
      if (window) window.setTimeout(function(){ unplug_download_timeout(hx, thiswindow.document); }, cn_unplug_prefint("download_timeout")*1000);
   } catch (e) {
      cn_unplug_err("downloadreference (get playlist)", e);
   }
}


/*
TODO - merge above
*/
function cn_unplug_downloadkeepvid(url, thiswindow){
   if (!url || url == "") return;
   
   var hx = new XMLHttpRequest;
   hx.open('POST', "http://keepvid.com/index_p/", true);
   hx.overrideMimeType('text/plain');
   
   cn_unplung_downloads_start++;
   unplug_download_update(thiswindow.document);
   hx.onreadystatechange = function () {
      try {
         if (hx.readyState == 4) {
            if(hx.status == 200) {
               cn_unplug_skimread("unplug://keepvid", "<keepvid>" + hx.responseText, thiswindow, hx.getAllResponseHeaders());
            } else {
               cn_unplug_skimread(url, "<err>"+cn_unplug_s("HTTPError")+hx.status, thiswindow, null);
            }
            cn_unplung_downloads_count++;
            unplug_download_update(thiswindow.document);
         }
      } catch(e){
        //cn_unplug_err("downloadkeepvid.internal", e);
      }
   };
   
   var dat = "url=" + escape(url) + "&site=" + escape(url);
   hx.setRequestHeader("Host", "keepvid.com");
   hx.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
   hx.setRequestHeader("Connection", "close");
   hx.setRequestHeader("Content-length", dat.length);
   hx.setRequestHeader("Accept", "text/*, */*;q=0");
   hx.send(dat);
   
   if (window) window.setTimeout(function(){ unplug_download_timeout(hx, thiswindow.document); }, cn_unplug_prefint("download_timeout")*1000);
}

/* decode playlist */
function cn_unplug_skimread(url, tx, thiswindow, heads){
//   if (heads)
//      alert(heads);
   
   try {
      if (!thiswindow || !thiswindow.document) return;
      var boo = thiswindow.document.getElementById("cn_photobooth");
      if (!boo) return;
      
      var out = "";
      var otype = "";
      
      if (cn_unplug_pref("developer")){
         out += "<TEXTAREA>" + cn_unplug_htmlspecialchars(tx)  + "</TEXTAREA><BR>&uarr; This is displayed because you have developer mode on.<BR>";
      }
      
      
      /* KNOWN WEBSITES - for ##head:only */
      if (url.indexOf("youtube.com") > 0 && url.indexOf("youtube.com") < 15){
         otype = "Youtube";
         
         var reg = /video_id=([^ ?/~#'"]*?)&.*t=([^ ?/~#'"]*?)[&"]/g;
         var rr;
         while (rr = reg.exec(tx)){
            var i = String(rr[1]);
            var t = String(rr[2]);
            if (i.length > 0 && t.length > 0 && url.indexOf(i) > 0) {
               var lnk = "http://youtube.com/get_video?video_id=" + i + "&t=" + t;
               out += "<B>" + cn_unplug_link(lnk, "url") + "</B><BR>"
               out += cn_unplug_lair_url(lnk, 0);
            }
         }
         
      } else if (0 <= url.indexOf("dailymotion.com")
      ){
         otype = "Dailymotion";
         // http://www.dailymotion.com/get/14/320x240/flv/1908504.flv?key=b26698fde5980398a09e34d42124885512af705
         // http://www.dailymotion.com/swf/1908504-zna6os8qkyzfwrx0upsjse4ee66v8qqcw2390uwk
         var id = url.substring(url.lastIndexOf("/")+1, url.lastIndexOf("-"));
         var key = url.substring(url.lastIndexOf("-")+1, url.length);
         if (id.length > 0 && key.length > 0){
            var lnk = "http://www.dailymotion.com/get/14/320x240/flv/" + id + ".flv?key" + key;
            out += "<B>" + cn_unplug_link(lnk, "url") + "</B><BR>"
            out += cn_unplug_lair_url(lnk, 0);
         }
      
      /* ASX */
      } else if (tx.indexOf("<ASX") >= 0 || tx.indexOf("<asx") >= 0){
         otype = "ASX";
         var ua = tx.split(/<entry/i);
         
         var rx = /<\s*ref[^>]href\s*=\s*["']?([^"']+)["']?/ig;
         var rxt = /<\s*Title\s*>(.*)<\s*\/\s*Title\s*>/i;
         for (i = 0; i < ua.length; i++){
            if (ua[i] && ua[i].length > 0){
               var rxr;
               while(rxr = rx.exec(ua[i])){
                  var uout = cn_unplug_url2(url, rxr[1]);
                  out += cn_unplug_link(uout, "url")
                  if (rxt.test(ua[i]))
                     out += "<P class=\"desc\">" + cn_unplug_striptext(rxt.exec(ua[i])[1]) + "</P>";
                  else
                     out += "<P class=\"desc\">" + cn_unplug_s("PlaylistNoTitle")+"</P>";
                  
                  out += cn_unplug_lair_url(rxr[1], 0);
               }
            }
         }
         
      } else if (url.indexOf("veoh.com") >= 0) {
         otype = "veoh.com (XML)";
         
         var reg = /([a-z]*hash[^=]*)="([^"]*)"/ig;
         var rr;
         while (rr = reg.exec(tx)) {
            if (rr[1] != "filehash") {
               var fu = "http://p-previews.veoh.com/previews/get.jsp?fileHash=" + rr[2];
               out += cn_unplug_link(fu, "url") + "<BR>"
               out += cn_unplug_lair_url(fu, 0);
               out += "<P class=\"desc\">" + cn_unplug_striptext(rr[1]) + "</P>";
            }
         }
         if (out == "") out = cn_unplug_s("PlaylistNothing")+cn_unplug_help("skim");

      /* SMIL (rm) */
      } else if (tx.indexOf("<SMIL") >= 0 || tx.indexOf("<smil") >= 0){
         otype = "SMIL";
         
         var rx = /<\s*(ref|animation|audio|img|text|textstream|video)([^>]*)>/ig; //global
         if (rx.test(tx)) {
            var z = tx.match(rx);
            for (var i = 0; i < z.length; i++) {
               var rs = /(?:src|href)\s*=\s*["']?([^"']+)["']?/i; //once
               var rt = /(?:title|alt)\s*=\s*["']?([^"']+)["']?/ig; //global
               var rtag = /<\s*([^\s>]*)/i; // returns <tag>
               
               //zz is < ... > item
               var zz = z[i];
               if (rs.test(zz)){
                  var uout = rs.exec(zz)[1];
                  uout = cn_unplug_url2(url, uout);
                  out += cn_unplug_link(uout, "url");
                  out += "<P class=\"desc\">";
                  if (rtag.test(zz))
                     out += rtag.exec(zz)[1] + ": ";
                  if (rt.test(zz)){
                     var tits = zz.match(rt);
                     for (var j = 0; j < tits.length; j++)
                        out += ", " + cn_unplug_striptext(tits[j]);
                  }
                  out += "</P>";
               }
               
               out += cn_unplug_lair_url(uout, 0);
            }
         }
         
      /* GVP (Google Video Player */
      } else if (tx.indexOf("gvp_version") >= 0){
         otype = "Google Video Player Playlist (GVP)";
         
         if (tx.indexOf("url:") >= 0){
         var uout = tx.substring(tx.indexOf("url:")+"url:".length, tx.length);
         if (uout.indexOf("\n") > 0) uout = uout.substring(0, uout.indexOf("\n"));
         if (uout.indexOf("\r") > 0) uout = uout.substring(0, uout.indexOf("\r"));
         
         var un = "";
         if (tx.indexOf("title:") >= 0) un = tx.substring(tx.indexOf("title:")+"title:".length, tx.length);
         if (un.indexOf("\n") > 0) un = un.substring(0, un.indexOf("\n"));
         if (un.indexOf("\r") > 0) un = uout.substring(0, un.indexOf("\r"));
         
         uout = cn_unplug_url2(url, uout);
         out += cn_unplug_link(uout, "url");
         
         if (un && un.length > 0){
            out += "<P class=\"desc\">";
            out += un;
            out += "</P>";
            }
            
         out += cn_unplug_lair_url(uout, 0);
      }
         
      /* KEEPVID */
      } else if (tx.indexOf("<keepvid>") >= 0){
         while (tx.toLowerCase().indexOf("href") >= 0) {
            var uout = "";
            tx = tx.substring(tx.toLowerCase().indexOf("href")+4, tx.length);
            tx = tx.substring(tx.indexOf("=")+1, tx.length);
            tx = cn_unplug_trim_spaces(tx);
            switch (tx.charAt(0)) {
               case "'":
                  tx = tx.substring(1, tx.length);
                  uout = tx.substring(0, tx.indexOf("'"));
                  break;
               case "\"":
                  tx = tx.substring(1, tx.length);
                  uout = tx.substring(0, tx.indexOf("\""));
                  break;
               default:
                  uout = tx.substring(0, tx.indexOf(" "));
                  break;
            }
            uout = cn_unplug_url2(url, uout);
            out += cn_unplug_link(uout, "url") + "<BR>";
            out += cn_unplug_lair_url(uout, 0);
         }
         otype="Special";
         out = cn_unplug_s("This_Data_Comes_From") + " <A href='http://keepvid.com' class='url' target='_new'>KeepVid</A>:<BR>" + ((out.length>0)?out:cn_unplug_s("PlaylistNothing"));
         
      /* VIDEODOWNLOADER */
      } else if ((tx.indexOf("../vd/logovd.gif") >= 0 && tx.indexOf("contenedor_interior_descargas") >= 0) || /* or is empty response */ (tx.indexOf("\"\"") >= 0 && tx.search(/[A-Za-z0-9<>]/) < 0)) {
         url = "unplug://videodownloader";
         tx = tx.substring(0, tx.indexOf("botdl.gif"));
         tx = tx.substring(tx.lastIndexOf("href"), tx.length)
         tx = tx.substring(tx.indexOf("\"")+1, tx.length)
         tx = tx.substring(0, tx.indexOf("\""))
         tx = tx.replace(/\\/g, "");
         if (tx.length > 2) {
            out += cn_unplug_link(unescape(tx), "url") + "<BR>"
            out += cn_unplug_lair_url(unescape(tx), 0);
         }
         /* tag */
         otype="Special";
         out = cn_unplug_s("This_Data_Comes_From") + " <A href='http://javimoya.com' class='url' target='_new'>javimoya.com</A>:<BR>" + ((out.length>0)?out:cn_unplug_s("PlaylistNothing"));
         
      /* XML PACKAGE (IFILM)*/
      } else if (tx.indexOf("<package>") >= 0) {
         var r = /<src>([^<]*)<\/src>/gi;
         var rr;
         while (rr = r.exec(tx)){
            if (rr[1] && String(rr[1]).length > 0) {
               out += cn_unplug_link(rr[1], "url") + "<BR>"
               out += cn_unplug_lair_url(rr[1], 0);
            }
         }
         /* tag */
         otype="XML Package";
         if (out == "") out = cn_unplug_s("PlaylistNothing")+cn_unplug_help("skim");
         
      /* AOL TEXT */
      } else if (tx.indexOf("assetId:") >= 0 || tx.indexOf("wmsid:") >= 0) {
         var r2 = /"(\/[^"]*)"/gi;
         var r2r;
         while (r2r = r2.exec(tx)){
            if (r2r[1] && String(r2r[1]).length > 0) {
               var lnk;
               
               lnk  = "http://progressive.stream.aol.com" + r2r[1];
               lnk = lnk.substring(0, lnk.indexOf(";")) + "_dl.mov";
               out += cn_unplug_link(lnk, "url") + "<BR>"
               out += "<P class=\"desc\">" + cn_unplug_striptext(lnk.substring(lnk.lastIndexOf("/")+1, lnk.lastIndexOf("_dl"))) + " (quicktime)</P>";
               out += cn_unplug_lair_url(lnk, 0);
               
               lnk = "mms://wms.stream.aol.com" + r2r[1];
               lnk = lnk.substring(0, lnk.indexOf(";")) + ".wmv";
               out += cn_unplug_link(lnk, "url") + "<BR>"
               out += "<P class=\"desc\">" + cn_unplug_striptext(lnk.substring(lnk.lastIndexOf("/")+1, lnk.lastIndexOf("."))) + " (mms)</P>";
               out += cn_unplug_lair_url(lnk, 0);
            }
         }
         
         var r = /"(http\:\/\/[^"]*)"/gi;
         var rr;
         while (rr = r.exec(tx)){
            if (rr[1] && String(rr[1]).length > 0) {
               out += cn_unplug_link(rr[1], "url") + "<BR>"
               out += cn_unplug_lair_url(rr[1], 0);
            }
         }
         /* tag */
         otype="ZOMG AOL DATA LOL!!!!11!!!";
         if (out == "") out = cn_unplug_s("PlaylistNothing")+cn_unplug_help("skim");
         
      /* PLS / Shoutcast */
      } else if (tx.indexOf("[playlist]") >=0) {
         otype = "PLS";
         tx += "\n";
         for (var i = 0; i < 100; i++){
            var rpls = new RegExp("file\\s*0*" + i + "\\s*=\\s*([^\\n\\r\\f]*)[\\n\\r\\f]", "i");
            var rplstt = new RegExp("title\\s*0*" + i + "\\s*=\\s*([^\\n\\r\\f]*)[\\n\\r\\f]", "i");
            if (rpls.test(tx)) {
               var uout = rpls.exec(tx)[1];
               uout = cn_unplug_url2(url, uout);
               out += cn_unplug_link(uout, "url");
               if (rplstt.test(tx))
                  out += "<P class=\"desc\">" + cn_unplug_striptext(rplstt.exec(tx)[1]) + "</P>";
               else
                  out += "<P class=\"desc\">" + cn_unplug_s("Track").replace('#1', i) + "</P>";
               out += cn_unplug_lair_url(uout, cn_unplug_me_media);
            }
         }
         
   /*      tx = tx + "\n";
         while (tx.indexOf("ile")>=0){
            tx = tx.substring(tx.indexOf("ile"), tx.length);
            tx = tx.substring(tx.indexOf("=")+1, tx.length);
            var uout = cnunhref(tx.substring(0, tx.indexOf("\n")));
            uout = cn_unplug_url2(url, uout);
            out += cn_unplug_link(uout, "url") + "<BR>";
         }
   */
         
      /* ERROR MESSAGE */
      } else if (tx.indexOf("<err>") >=0) {
         otype = "failed";
         out = "Error: " + tx.substring(tx.indexOf("<err>"+5, tx.length));
      
      
      /* ASF Ref= */
      } else if (tx.indexOf("Ref1") >= 0) {
         otype = "ASF-Redirect";
         tx += "\n";
         var rgx = new RegExp("Ref([0-9]+)\s*=([^:]*)://([^\n\r]*)", "ig");
         var rgxres;
         var tou = 20;
         while (rgxres = rgx.exec(tx)) {
            if (--tou < 1) {
               throw "Too many items in ASX References Playlist";
               break;
            }
            var uout = rgxres[2] + "://" + rgxres[3];
            out += cn_unplug_link(uout, "url");
            out += "<P class=\"desc\">" + cn_unplug_s("Track").replace('#1', rgxres[1]) + "</P>";
            out += cn_unplug_lair_url(uout, cn_unplug_me_media);
            
            uout = "mms://" + rgxres[3];
            out += cn_unplug_link(uout, "url");
            out += "<P class=\"desc\">" + cn_unplug_s("Track").replace('#1', rgxres[1]) + " (mms)</P>";
            out += cn_unplug_lair_url(uout, cn_unplug_me_media);
         }
         if (out == "") out = cn_unplug_s("PlaylistNothing")+cn_unplug_help("skim");
      
      
      /* M3U PLAIN TEXT */
      } else if (tx.indexOf("://") >= 0 && tx.indexOf("<") < 0 && tx.indexOf(">") < 0 && (tx.indexOf("://") < tx.indexOf("=") || tx.indexOf("=") < 0)) {
         otype = "M3U";
         tx += "\n";
         while (tx.indexOf("\n") >= 0){
            var ou = tx.substring(0, tx.indexOf("\n"));
            if (ou.toLowerCase().indexOf("#extinf") >= 0 && ou.indexOf("://") >= 0 && ou.indexOf("[") >= 0 && ou.indexOf("]") >= 0){
               var oul = ou.substring(ou.indexOf("]")+1, ou.length);
               if (oul.charAt(0) == " ") oul = oul.substring(1, oul.length);
               out += cn_unplug_link(oul, "url");
               out += "<P class=\"desc\">" + cn_unplug_striptext(ou.substring(ou.indexOf("[")+1, ou.indexOf("]"))) + "</P>";
               out += cn_unplug_lair_url(oul, 0);
            } else if (ou.indexOf("://") > 0) {
               out += cn_unplug_link(ou, "url") + "<BR>";
               out += cn_unplug_lair_url(ou, 0);
            }
            tx = tx.substring(tx.indexOf("\n")+1, tx.length);
         }
         if (out == "") out = cn_unplug_s("PlaylistNothing")+cn_unplug_help("skim");
      
      //EMBEDDED HTML
      /*
      } else if ((tx.indexOf("<EMBED") >= 0 || tx.indexOf("<embed") >= 0) && (tx.indexOf("<BODY") >= 0 || tx.indexOf("<body") >= 0)) {
         otype = "HTML";
         var rgx1 = new RegExp("src=[\"\'](^[\"\']+)[\"\']", "ig");
         var rgx2 = new RegExp("src=([^ >]+)[ >]", "ig");
         var rgxres;
         while (rgxres = rgx1.exec(tx)) {
            out += cn_unplug_link(rgxres[1], "url");
            out += cn_unplug_lair_url(rgxres[1], cn_unplug_me_media);
         }
         while (rgxres = rgx2.exec(tx)) {
            out += cn_unplug_link(rgxres[1], "url");
            out += cn_unplug_lair_url(rgxres[1], cn_unplug_me_media);
         }
         if (out == "") out = cn_unplug_s("PlaylistNothing")+cn_unplug_help("skim");
         
      //STRANGE INCLUDE FILE
      } else if (tx.indexOf("video_id=") >= 0){
         otype = "Flurl";
         
         tx = tx.substring(tx.indexOf("video_id=") + "video_id=".length, tx.length);
         if (tx.indexOf("&") > 0)
            tx = tx.substring (0, tx.indexOf("&"));
         
         out += cn_unplug_link(tx, "url");
         out += cn_unplug_lair_url(tx, cn_unplug_me_media);
         
      */
      
      /* MOVIEURL XML */
      } else if (tx.toLowerCase().indexOf("<movieurl") >= 0 ){
         otype = "XML MovieURL";
         var reg = /<MovieURL[^>]*>([^<]+)<\/MovieURL/ig
         var regres;
         while (regres = reg.exec(tx)) {
            out += cn_unplug_link(regres[1], "url");
            out += cn_unplug_lair_url(regres[1], cn_unplug_me_media);
         }
         if (out == "") out = cn_unplug_s("PlaylistNothing")+cn_unplug_help("skim");
      
      /* myspace music style */
      } else if (tx.indexOf("<song") >= 0) {
         otype="MySpace Songbook";
         
         var reg = /<song ([^>]*)>/gi;
         var rr;
         while (rr = reg.exec(tx)) {
            var t = rr[1];
            var t_title = "";
            
            if (t.indexOf("title=") >= 0) {
               t_title = t.substring(t.indexOf("title="), t.length);
               t_title = t_title.substring(t_title.indexOf("\"")+1, t_title.length);
               t_title = t_title.substring(0, t_title.indexOf("\""));
            }
            
            var r2 = /url="([^"]*\/\/[^"]*)"/gi;
            var rr2;
            while (rr2 = r2.exec(t)){
               var tu = rr2[1];
               if (tu.indexOf("HitCount") < 0 && tu.indexOf("//cache") < 0) {
                  out += cn_unplug_link(tu, "url") + "<BR>"
                  if (t_title.length > 0)
                     out += "<P class=\"desc\">" + cn_unplug_striptext(t_title) + "</P>";
                  out += cn_unplug_lair_url(tu, 0);
               }
            }
         
            var r3 = /imagename="([^"]*\/\/[^"]*)"/gi;
            var rr3;
            while (rr3 = r3.exec(t)){
               var tu = rr3[1];
               tu = tu.replace("_m.", "_l.");
               out += cn_unplug_link(tu, "url") + "<BR>"
               if (t_title.length > 0)
                  out += "<P class=\"desc\">Image</P>";
               out += cn_unplug_lair_url(tu, 0);
            }
         }
         if (out == "") out = cn_unplug_s("PlaylistNothing")+cn_unplug_help("skim");

      /* college humor, etc, urlencoded searchstring style hrefs */
      } else if (tx.indexOf("&") >= 0
         && tx.indexOf("=") > 0
         && tx.indexOf("\n") < 0
         && tx.indexOf("\r") < 0
      ) {
         otype="AJAX Request (No Escape)";
         
         var itext = tx.split("&");
         for (var i = 0; i < itext.length; i++){
            var it = itext[i];
            it = it.substring(it.indexOf("=") + 1, it.length);
            if (it.toUpperCase().indexOf("%3A%2F%2F") >= 0 && it.indexOf("://") < 0)
               it = unescape(it);
            
            if (it.indexOf("://") >= 0) {
               if (cn_unplug_pref("show_poor_suggestions")
                || it.indexOf(".jp") < 0 ) { /* no jpe?g */
                  
                  var abold = false;
                  
                  if (it.indexOf(".flv") >= 0)
                     abold = true;
                  
                  /* link */
                  if (abold) out += "<B>";
                  out += cn_unplug_link(it, "url") + "<BR>"
                  out += cn_unplug_lair_url(it, 0);
                  if (abold) out += "</B>";
               }
            }
         }

         if (out == "") out = cn_unplug_s("PlaylistNothing")+cn_unplug_help("skim");
         
      } else {
         var l2 = new Array();
         
         otype = "XML (testing)";
         
         /* hack out XML CDATAs */
         tx = cn_unplug_remove_text(tx, "<![CDATA[");
         tx = cn_unplug_remove_text(tx, "]]>");
         
         /* do it */
         cn_unplug_parsetext(l2, tx, url);
         
         /*
         Fix
         */
         for (var i = 0; i < l2.length; i++)
         {
            var u = l2[i];
            
            /* quotes? */
            if (u.charAt(0) == '"' || u.charAt(0) == '\'')
               u =  u.substring(1, u.length);
            if (u.charAt(u.length-1) == '"' || u.charAt(u.length-1) == '\'')
               u =  u.substring(0, u.length-1);
            
            /* duplicates? */
            for (var j = 0; j < i; j++)
            {
               if (l2[j] == u)
                  u = "";
            }
            
            /* relative url */
            u = cn_unplug_url2(url, u);
            
            /* save */
            l2[i] = u;
         }
         
         /*
         if only showing good links, check if some are good links (bold) and
         just display them
         */
         var there_are_some_good_links = false;
         if (cn_unplug_pref("show_poor_suggestions") == false)
         {
            for (i = 0; i < l2.length; i++)
            {
               if (cn_unplug_playlist_good_link(l2[i]))
               {
                  there_are_some_good_links = true;
                  break;
               }
            }
         }
         
         /*
         Print
         */
         for (var i = 0; i < l2.length; i++)
         {
            if (l2[i] != "")
            {
               var bold = false;
               if (cn_unplug_playlist_good_link(l2[i]))
                  bold = true;
               
               if (there_are_some_good_links == false || bold == true)
               {
                  if (bold)
                     out += "<B>";
                  out += cn_unplug_link(l2[i], "url")
                  if (bold)
                     out += "</B>";
                  out += "<BR>";
                  out += cn_unplug_lair_url(l2[i], 0);
               }
            }
         }
      
      }
      
      /*
      // MISC list-based
      } else if (tx.indexOf("%3A%2F%2F") >= 0 || tx.indexOf("://") >= 0){
         otype = "Include / Other";
         
         var rgxres;
         
         var rgx1 = new RegExp("[^\'\"a-z%]([a-z%]*://[^ ><]*)[ ><]", "ig");
         while (rgxres = rgx1.exec(tx)) {
            var a = rgxres[1];
            if (a.indexOf("%") >= 0
            && (a.indexOf("%") < a.indexOf("?") || a.indexOf("?") < 0))
               a = unescape(a);
            if (a.substring(a.length-2, a.length) == "]]")
               a = a.substring(0, a.length-2);
            out += cn_unplug_link(a, "url");
            out += cn_unplug_lair_url(a, cn_unplug_me_media);
         }
         
         var rgx2 = new RegExp("[\"\']([a-z%]*://[^><\"\']*)[\"\']", "ig");
         while (rgxres = rgx2.exec(tx)) {
            var a = rgxres[1];
            if (a.indexOf("%") >= 0
            && (a.indexOf("%") < a.indexOf("?") || a.indexOf("?") < 0))
               a = unescape(a);
            out += cn_unplug_link(a, "url");
            out += cn_unplug_lair_url(a, cn_unplug_me_media);
         }
         
         if (out == "") out = cn_unplug_s("PlaylistNothing")+cn_unplug_help("skim");
      
      }
      */

      /* UNKNOWN XML/HTML */
      /*
      } else if (tx.indexOf("<xml") >= 0 || tx.indexOf("<XML") >= 0 || tx.indexOf("<html") >= 0 || tx.indexOf("<HTML") >= 0 || tx.indexOf("<RDF") >= 0 || tx.indexOf("<rdf") >= 0 || tx.indexOf("<rss") >= 0 || tx.indexOf("<RSS") >= 0){
         out += cn_unplug_s("PlaylistHTML")+cn_unplug_help("skim");
         
      */
      /* UNKNOWN OTHER */
      /*
      } else {
         out += cn_unplug_s("PlaylistUnknown")+cn_unplug_help("skim");
      }
      */
      
      var p = thiswindow.document.createElement("div");
      p.innerHTML = cn_unplug_s("PlaylistName").replace('#1', otype).replace('#2', "<B title='" + url + "'>" + cn_unplug_long(url) + "</B>") + "<BR>" + out
      p.className = "booth";
      boo.appendChild(p);
   } catch (e){
      cn_unplug_err("skimread (decode playlist)", e);
   }
}

/* update screen */
function unplug_download_update(doc){
   if (!doc) return
   
   var div = doc.getElementById('cn_undown');
   if (div) {
      div.style.display = '';
      var tx = "";
      if (cn_unplung_timeout_count != 0) {
         tx = cn_unplug_s("PlayListStatusWaitTimeout")
            .replace('#1', cn_unplung_downloads_start - cn_unplung_downloads_count)
            .replace('#2', cn_unplung_timeout_count);
         if (cn_unplung_downloads_count == cn_unplung_downloads_start) {
            tx = cn_unplug_s("PlayListStatusTimeout")
               .replace('#1', cn_unplung_downloads_start-cn_unplung_timeout_count)
               .replace('#2', cn_unplung_timeout_count);
         }
      } else {
         tx = cn_unplug_s("PlayListStatusWait")
            .replace('#1', cn_unplung_downloads_start - cn_unplung_downloads_count)
            .replace('#2', cn_unplung_downloads_start);
         if (cn_unplung_downloads_count == cn_unplung_downloads_start) {
            //complete
            //div.style.display = 'none';
            tx = cn_unplug_s("PlayListStatusDone")
               .replace('#1', cn_unplung_downloads_start);
         }
      }
      div.innerHTML = tx;
   }
}

function unplug_download_timeout(hx, doc){
   if (!hx) return;
   try{
      if (hx.readyState == 4) {
         if (hx.status != 200) {
            //failed status code, should be picked up in "ok" version
         }
         hx.abort();
         return;
      }
      // TIMEOUT
      hx.abort();
   }catch(e){
      cn_unplug_err("on download timeout", e);
      return;
   }
   
   cn_unplung_timeout_count++;
   unplug_download_update(doc);
}




function cn_unplug_parsetext(l2, tx, url)
{
   /*
   First, split the item into <...> .... segments.
   */
   var tx_parts = tx.split("<");
   for (var i = 0; i < tx_parts.length; i++)
   {
      var tx_part = tx_parts[i];
      var gt_indx = tx_part.indexOf(">");
      if (gt_indx < 0)
         gt_indx = tx_part.length;
      
      var intag = tx_part.substring(0, gt_indx);
      var outtag = tx_part.substring(gt_indx+1, tx_part.length);
      
      /*
      next, split up the <...> into <type name=value name=value ...>
      */
      var intag_phrases = cn_unplug_xmlsplit(intag);
      for (var j = 0; j < intag_phrases.length; j++)
      {
         var intag_phrase = intag_phrases[j];
         if (j == 0)
         {
            /*
            Treat tagname and innerHTML as a key/value pair
            */
            cn_unplug_parsetext_pair(l2, intag_phrase, outtag, url);
         }
         else
         {
            /*
            split key=value pairs
            */
            var intag_phrase_indx = intag_phrase.indexOf("=");
            cn_unplug_parsetext_pair(
               l2,
               intag_phrase.substring(0, intag_phrase_indx),
               intag_phrase.substring(intag_phrase_indx+1, intag_phrase.length),
               url
            );
         }
      } /* phrases */
   } /* parts */
}


function cn_unplug_parsetext_pair(l2, key, val, url)
{
   if (
      val.indexOf("/") >= 0
      ||
      (
         val.lastIndexOf(".") >  0
         &&
         val.lastIndexOf(".") <  val.length - 2
         &&
         val.lastIndexOf(".") >= val.length - 5
      )
   )
   {
      /* history.com cludge */
      if (url.indexOf("history.com") >= 0 && val.indexOf("/19") >= 0)
         return;
      
      if (val.indexOf("getflashplayer") >= 0    // flash
       || val.indexOf("/x-") >= 0               // mime types
       || val == url
      ) return;
      
      if (val.indexOf(".jpg") < 0
       && val.indexOf(".png") < 0
       && val.indexOf(".gif") < 0
       && val.indexOf(".jpeg") < 0)
      {
         l2[l2.length] = val;
      }
   }
}


/*
   cn_unplug_xmlsplit
   parses string "aaaa bbbbb ccccc dddddd" from a "<.....>"
   can deal with trailing /
*/
function cn_unplug_xmlsplit(tx)
{
   var r = Array();
   var ptr = 0;
   
   if (tx.charAt(tx.length-1) == '/')
      tx = tx.substring(0, tx.length -1);
   
   for (var endptr=0; endptr < tx.length; endptr++)
   {
      switch (tx.charAt(endptr))
      {
         case ' ':
         case '\t':
         case '\n':
         case '\r':
         {
            if (endptr > ptr + 1) /* contract multiple spaces */
               r[r.length] = tx.substring(ptr, endptr);
            ptr = endptr;
            break;
         }
         case '"':
         {
            do {
               endptr++;
            }
            while (endptr < tx.length && tx.charAt(endptr) != '"');
            break;
         }
         case '\'':
         {
            do {
               endptr++;
            }
            while (endptr < tx.length && tx.charAt(endptr) != '\'');
            break;
         }
         default:
            break;
      }
   }
   
   r[r.length] = tx.substring(ptr, tx.length);
   
   return r;
}


function cn_unplug_trim_spaces(tx)
{
   while (tx.charAt(0) == ' ' && tx.length > 1)
   {
      tx = tx.substring(1, tx.length);
   }
   while (tx.charAt(tx.length -1) == ' ' && tx.length > 1)
   {
      tx = tx.substring(0, tx.length-1);
   }
   return tx;
}


function cn_unplug_remove_text(tx, a)
{
   while (tx.indexOf(a) >= 0)
   {
      tx = tx.substring(0, tx.indexOf(a)) + tx.substring(tx.indexOf(a)+a.length, tx.length);
   }
   return tx;
}


function cn_unplug_playlist_good_link(url)
{
   if (0 <= url.indexOf(".flv")
    || 0 <= url.indexOf("crunchyroll.com/getitem")
   ) {
      return true;
   }
   return false;
}

/*
binary version of XMLHttpRequest
*/
function cn_unplug_downloadreference_binary(url, thiswindow, postdata_in)
{
   cn_unplug_skimread(url, "<err>This file requires binary downloads or uploads. This is unavailable for this version of UnPlug", thiswindow, null);
}


/*

GET http://www.myvideo.de/movie/1015482 HTTP/1.1\r\n --> 302 Temp Redir
as on here: http://www.isnichwahr.de/redirect24359.html



nsCOMPtr<nsIURI> sourceUrl;
IoService()->NewURI(sourceUri, nsnull, nsnull, getter_AddRefs(sourceUrl));
nsCOMPtr<nsIChannel> sourceChannel;
IoService()->NewChannelFromURI(sourceUrl, getter_AddRefs(sourceChannel));

nsCOMPtr<nsIUploadChannel> uploadChannel = do_QueryInterface(sourceChannel,
&rv);
nsCOMPtr<nsIHttpChannel> httpChannel = do_QueryInterface(sourceChannel,
&rv);

nsCString contentType("application/x-www-form-urlencoded");
uploadChannel->SetUploadStream(_istream, contentType, postText.size());

nsCString requestMethod("POST");
httpChannel->SetRequestMethod(requestMethod);

sourceChannel->SetNotificationCallbacks(progressStrreamListener);
sourceChannel->AsyncOpen(strreamListener, null);

After AsyncOpen modal dialog is displayed, which waits for HTTP transaction
end. 


*/