/*       _        ___
    /\ / /___    / _ \ /\ /\  _ ___
   / // // _ \  / // // // // // _ \
  / // // // / / ___// // // // // /
  \___//_//_/ /_/   /_/ \___/ \_  /
                             \___/

  Copyright (c) 2006, 2007 CompuNach
  Released under the GNU GPL 2.0 or any later version, Copyleft @ 2006
  
  Note: You should have received a copy of the GNU General Public License along
    with this program; if not, visit fsf.org, or write to the Free Software
    Foundation Inc, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
  
  Visit the website:
     unplug.mozdev.org
  
  
  THIS FILE contains scripts for streamsave.xul
  
*/

// mux extension vcodec acodec
const cn_unplug_convmatrix = ["raw/raw/0/0", "raw/mp3/0/mp3", "ts/mpg/mp2v/mpga", "mov/mov/0/0" /* don't know */, "avi/avi/divx/mpga", "wmv/wmv/0/0", "ogg/ogg/0/0", "asf/asf/divx/mpga"];

// LOCALE
var gBundle = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
var unplugstrings = gBundle.createBundle("chrome://unplug/locale/unplug.properties");


function cn_unplug_streamgo(){
   try {
      var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
      var url= window.document.getElementById('src_url').value;
      var dest = window.document.getElementById('dst_url').value;
      var msplit = cn_unplug_convmatrix[parseInt(window.document.getElementById('mtype').value)].split("/");
      var mux = msplit[0];
      
      dest = dest.replace(/\\/g, "/");
      
      var vlc_loc = prefs.getCharPref("extensions.cn_unplug.prog_lo_vlc");
      if (!vlc_loc || vlc_loc == "") {
         alert("Not found: VLC");
         return;
      }
      var file = Components.classes["@mozilla.org/file/local;1"]
         .createInstance(Components.interfaces.nsILocalFile);
      file.initWithPath(vlc_loc);
      var process = Components.classes["@mozilla.org/process/util;1"]
         .createInstance(Components.interfaces.nsIProcess);
      process.init(file);
      
      var args = [url];
      var twostep = false;
      
      prefs.setIntPref("extensions.cn_unplug.stream_action_value", window.document.getElementById('wantsto').value);
      
      switch (window.document.getElementById('wantsto').value) {
         case 1:
         case "1":
         // save + play
            args[args.length] = ":sout=#duplicate{dst=display,dst=std{access=file,mux=" + mux + ",url=\"" + dest + "\"}}";
            break;
         case 2:
         case "2":
         // save
            args[args.length] = ":demux=dump";
            args[args.length] = ":demuxdump-file=" + dest;
            break;
         case 3:
         case "3":
         // play
            //no sout instr
            break;
         case '4':
         case 4:
         // save play different
            alert(unplugstrings.GetStringFromName("StreamSave2Step"));
            
            //save
            args[args.length] = ":demux=dump";
            args[args.length] = ":demuxdump-file=" + dest;
            
            //2step
            twostep = true;
            window.arguments[1] //parent window
               .setTimeout("cn_unplug_streamzoo(\"" + dest + "\");", 15000); // 15 SECONDS!
            
            break;
         default:
            alert("Not valid option");
            break;
      }
      if (window.document.getElementById('saveall').checked)
         args[args.length] = "--sout-all";
      if (window.document.getElementById('quitvlc').checked)
         args[args.length] = "vlc:quit";
      try {
		if (prefs.getIntPref("extensions.cn_unplug.prog_vlc_new_player") == 1
		|| (prefs.getIntPref("extensions.cn_unplug.prog_vlc_new_player") == -1 && vlc_loc.search(/^[A-Z]:/i) >= 0)) {
           args[args.length] = "--no-one-instance";
		}
	  } catch(e) {}
      
      process.run(false, args, args.length);
      
      window.close()
  } catch (e) {
      alert("UnPlug! StreamWizz Error: " + e)
  }
}

function cn_unplug_stream_pop(){
   try{
      window.document.getElementById('cn_unplug_stream').getButton('accept').focus();
      
      var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
      
      var url = window.arguments[0];
      window.document.getElementById('src_url').value = url;
      
      var loci = url;
      if (loci.lastIndexOf("#")>0) loci = loci.substring(0, loci.lastIndexOf("#"));
      if (loci.lastIndexOf("?")>0) loci = loci.substring(0, loci.lastIndexOf("?"));
      loci = loci.substring(loci.lastIndexOf("/")+1, loci.length);
      loci = cn_unplug_dtime() + "_" + loci;
      
      var dir = "";
      try {
         dir = prefs.getCharPref("browser.download.dir");
      } catch (e){ }
      if (dir == "") try {
         dir = prefs.getCharPref("browser.download.defaultFolder");
      } catch (e){ }
      if (dir == "") try {
         dir = prefs.getCharPref("browser.download.lastDir");
      } catch (e){ }
      if (dir == "") dir = "[#ERROR: DIRECTORY REQUIRED]";
      
      loci =  dir + "/" + loci.replace(/[^0-9a-zA-Z\._-]/g, "_");
      loci = loci.replace(/\/{2,}/g, "/");
      window.document.getElementById('dst_url').value = loci;
      
      switch (loci.substring(loci.lastIndexOf(".")+1, loci.length)){
         case "mp3":
         case "pls":
            window.document.getElementById('mtype').value = "1";
            break;
         case "mpg":
         case "mpeg":
            window.document.getElementById('mtype').value = "2";
            break;
         case "mov":
            window.document.getElementById('mtype').value = "3";
            break;
         case "avi":
            window.document.getElementById('mtype').value = "4";
            break;
         case "wmv":
            window.document.getElementById('mtype').value = "5";
            break;
         case "ogg":
            window.document.getElementById('mtype').value = "6";
            break;
         case "asf":
            window.document.getElementById('mtype').value = "7";
            break;
         default:
            window.document.getElementById('mtype').value = "7"; //Generic default is ASF because it can cope with anything!
            break;
      }
      
      window.document.getElementById('wantsto').value = prefs.getIntPref("extensions.cn_unplug.stream_action_value");
      
      cn_unplug_stream_fixext();
  } catch (e) {
      alert("Unplug: Error when starting dialog!\nError was:\n" + e);
      window.close();
  }
}


function cn_unplug_stream_fixext(){
   var dv = window.document.getElementById('dst_url').value;
   var msplit = cn_unplug_convmatrix[parseInt(window.document.getElementById('mtype').value)].split("/");
   if (dv.lastIndexOf('.') > 0)
      dv = dv.substring(0, dv.lastIndexOf('.'));
   window.document.getElementById('dst_url').value = dv + '.' + msplit[1];
}

function cn_unplug_dtime(){
   var d = new Date();
   return "" + cn_unplug_zpad(d.getFullYear()) + cn_unplug_zpad(d.getMonth()) + cn_unplug_zpad(d.getDate()) + "_" + cn_unplug_zpad(d.getHours()) + cn_unplug_zpad(d.getMinutes())  + cn_unplug_zpad(d.getSeconds());
}

function cn_unplug_zpad(n){
   if (n < 10) return "0" + n;
   return n;
}

